# Copyright (c) 2012 The Chromium Authors. All rights reserved.
#
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

{
  'targets': [
    {
      'target_name': 'browser_ui',
      'type': 'static_library',
      'variables': { 'enable_wexit_time_destructors': 1, },
      # Since browser and browser_ui actually depend on each other,
      # we must omit the dependency from browser_extensions to browser.
      # However, this means browser_ui and browser should more or less
      # have the same dependencies. Once browser_ui is untangled from
      # browser, then we can clean up these dependencies.
      'dependencies': [
        'app/policy/cloud_policy_codegen.gyp:policy',
        'autofill_regexes',
        'browser_extensions',
        'browser/performance_monitor/performance_monitor.gyp:performance_monitor',
        'cert_logger_proto',
        'chrome_resources.gyp:chrome_extra_resources',
        'chrome_resources.gyp:chrome_resources',
        'chrome_resources.gyp:chrome_strings',
        'chrome_resources.gyp:platform_locale_settings',
        'chrome_resources.gyp:theme_resources',
        'common',
        'common/extensions/api/api.gyp:api',
        'common_net',
        'debugger',
        'in_memory_url_index_cache_proto',
        'installer_util',
        'safe_browsing_proto',
        'safe_browsing_report_proto',
        'feedback_proto',
        'variations_seed_proto',
        '../build/temp_gyp/googleurl.gyp:googleurl',
        '../content/content.gyp:content_browser',
        '../content/content.gyp:content_common',
        '../crypto/crypto.gyp:crypto',
        '../device/device.gyp:device_bluetooth',
        '../media/media.gyp:media',
        '../net/net.gyp:net_with_v8',
        '../ppapi/ppapi_internal.gyp:ppapi_ipc',  # For PpapiMsg_LoadPlugin
        '../printing/printing.gyp:printing',
        '../skia/skia.gyp:skia',
        '../sync/protocol/sync_proto.gyp:sync_proto',
        # TODO(akalin): Depend only on syncapi_service from sync.
        '../sync/sync.gyp:syncapi_core',
        '../sync/sync.gyp:syncapi_service',
        '../sync/sync.gyp:sync_notifier',
        '../third_party/adobe/flash/flash_player.gyp:flapper_version_h',
        '../third_party/bzip2/bzip2.gyp:bzip2',
        '../third_party/cacheinvalidation/cacheinvalidation.gyp:cacheinvalidation',
        '../third_party/cacheinvalidation/cacheinvalidation.gyp:cacheinvalidation_proto_cpp',
        '../third_party/cld/cld.gyp:cld',
        '../third_party/expat/expat.gyp:expat',
        '../third_party/hunspell/hunspell.gyp:hunspell',
        '../third_party/icu/icu.gyp:icui18n',
        '../third_party/icu/icu.gyp:icuuc',
        '../third_party/leveldatabase/leveldatabase.gyp:leveldatabase',
        '../third_party/libjingle/libjingle.gyp:libjingle',
        '../third_party/libphonenumber/libphonenumber.gyp:libphonenumber',
        '../third_party/libusb/libusb.gyp:libusb',
        '../third_party/libxml/libxml.gyp:libxml',
        '../third_party/npapi/npapi.gyp:npapi',
        '../third_party/re2/re2.gyp:re2',
        '../third_party/zlib/zlib.gyp:zlib',
        '../ui/base/strings/ui_strings.gyp:ui_strings',
        '../ui/compositor/compositor.gyp:compositor',
        '../ui/surface/surface.gyp:surface',
        '../ui/ui.gyp:ui',
        '../ui/ui.gyp:ui_resources',
        '../ui/web_dialogs/web_dialogs.gyp:web_dialogs',
        '../v8/tools/gyp/v8.gyp:v8',
        '../webkit/support/webkit_support.gyp:glue',
        '../webkit/support/webkit_support.gyp:user_agent',
        '../webkit/support/webkit_support.gyp:webkit_resources',
        '../webkit/support/webkit_support.gyp:webkit_storage',
      ],
      'include_dirs': [
        '..',
        '<(INTERMEDIATE_DIR)',
        # Needed by pepper_flash_component_installer.cc.
        '<(SHARED_INTERMEDIATE_DIR)',
      ],
      'defines': [
        '<@(nacl_defines)',
      ],
      'direct_dependent_settings': {
        'defines': [
          '<@(nacl_defines)',
        ],
      },
      'export_dependent_settings': [
        '../sync/sync.gyp:sync_notifier',
      ],
      'sources': [
        # All .cc, .h, .m, and .mm files under browser/ui except for:
        # * tests and mocks.
        'browser/ui/alternate_error_tab_observer.cc',
        'browser/ui/alternate_error_tab_observer.h',
        'browser/ui/android/android_about_app_info.cc',
        'browser/ui/android/android_about_app_info.h',
        'browser/ui/android/autofill/autofill_external_delegate.cc',
        'browser/ui/android/autofill/autofill_external_delegate.h',
        'browser/ui/android/certificate_viewer_android.cc',
        'browser/ui/android/chrome_http_auth_handler.cc',
        'browser/ui/android/chrome_http_auth_handler.h',
        'browser/ui/android/color_chooser_android.cc',
        'browser/ui/android/extensions/extension_install_dialog_android.cc',
        'browser/ui/android/extensions/extension_view_android.cc',
        'browser/ui/android/extensions/extension_view_android.h',
        'browser/ui/android/external_protocol_dialog_android.cc',
        'browser/ui/android/javascript_app_modal_dialog_android.cc',
        'browser/ui/android/login_prompt_android.cc',
        'browser/ui/android/simple_message_box_android.cc',
        'browser/ui/android/ssl_client_certificate_selector.cc',
        'browser/ui/android/status_tray_android.cc',
        'browser/ui/android/tab_contents/chrome_web_contents_view_delegate_android.cc',
        'browser/ui/android/tab_contents/chrome_web_contents_view_delegate_android.h',
        'browser/ui/android/tab_model/tab_model.cc',
        'browser/ui/android/tab_model/tab_model.h',
        'browser/ui/android/tab_model/tab_model_list.cc',
        'browser/ui/android/tab_model/tab_model_list.h',
        'browser/ui/android/tab_restore_service_delegate_android.cc',
        'browser/ui/android/window_android_helper.cc',
        'browser/ui/android/window_android_helper.h',
        'browser/ui/app_list/app_list_controller.h',
        'browser/ui/app_list/app_list_controller.cc',
        'browser/ui/app_modal_dialogs/app_modal_dialog.cc',
        'browser/ui/app_modal_dialogs/app_modal_dialog.h',
        'browser/ui/app_modal_dialogs/app_modal_dialog_queue.cc',
        'browser/ui/app_modal_dialogs/app_modal_dialog_queue.h',
        'browser/ui/app_modal_dialogs/javascript_app_modal_dialog.cc',
        'browser/ui/app_modal_dialogs/javascript_app_modal_dialog.h',
        'browser/ui/app_modal_dialogs/javascript_dialog_creator.cc',
        'browser/ui/app_modal_dialogs/javascript_dialog_creator.h',
        'browser/ui/app_modal_dialogs/native_app_modal_dialog.h',
        'browser/ui/ash/ash_init.cc',
        'browser/ui/ash/ash_init.h',
        'browser/ui/ash/app_list/app_list_controller_ash.h',
        'browser/ui/ash/app_list/app_list_controller_ash.cc',
        'browser/ui/ash/ash_util.cc',
        'browser/ui/ash/ash_util.h',
        'browser/ui/ash/caps_lock_handler.cc',
        'browser/ui/ash/caps_lock_handler.h',
        'browser/ui/ash/brightness_controller_chromeos.cc',
        'browser/ui/ash/brightness_controller_chromeos.h',
        'browser/ui/ash/chrome_launcher_prefs.cc',
        'browser/ui/ash/chrome_launcher_prefs.h',
        'browser/ui/ash/chrome_shell_delegate.cc',
        'browser/ui/ash/chrome_shell_delegate.h',
        'browser/ui/ash/event_rewriter.cc',
        'browser/ui/ash/event_rewriter.h',
        'browser/ui/ash/extension_utils.cc',
        'browser/ui/ash/extension_utils.h',
        'browser/ui/ash/ime_controller_chromeos.cc',
        'browser/ui/ash/ime_controller_chromeos.h',
        'browser/ui/ash/launcher/browser_launcher_item_controller.cc',
        'browser/ui/ash/launcher/browser_launcher_item_controller.h',
        'browser/ui/ash/launcher/chrome_launcher_controller.cc',
        'browser/ui/ash/launcher/chrome_launcher_controller.h',
        'browser/ui/ash/launcher/launcher_app_icon_loader.cc',
        'browser/ui/ash/launcher/launcher_app_icon_loader.h',
        'browser/ui/ash/launcher/launcher_app_tab_helper.cc',
        'browser/ui/ash/launcher/launcher_app_tab_helper.h',
        'browser/ui/ash/launcher/launcher_context_menu.cc',
        'browser/ui/ash/launcher/launcher_context_menu.h',
        'browser/ui/ash/launcher/launcher_favicon_loader.cc',
        'browser/ui/ash/launcher/launcher_favicon_loader.h',
        'browser/ui/ash/launcher/launcher_item_controller.cc',
        'browser/ui/ash/launcher/launcher_item_controller.h',
        'browser/ui/ash/launcher/shell_window_launcher_controller.cc',
        'browser/ui/ash/launcher/shell_window_launcher_controller.h',
        'browser/ui/ash/screenshot_taker.cc',
        'browser/ui/ash/screenshot_taker.h',
        'browser/ui/ash/tabs/dock_info_ash.cc',
        'browser/ui/ash/user_action_handler.cc',
        'browser/ui/ash/user_action_handler.h',
        'browser/ui/ash/volume_controller_chromeos.cc',
        'browser/ui/ash/volume_controller_chromeos.h',
        'browser/ui/ash/window_positioner.cc',
        'browser/ui/ash/window_positioner.h',
        'browser/ui/aura/chrome_browser_main_extra_parts_aura.cc',
        'browser/ui/aura/chrome_browser_main_extra_parts_aura.h',
        'browser/ui/aura/tabs/dock_info_aurax11.cc',
        'browser/ui/autofill/autofill_dialog_controller.cc',
        'browser/ui/autofill/autofill_dialog_controller.h',
        'browser/ui/autofill/autofill_dialog_view.cc',
        'browser/ui/autofill/autofill_dialog_view.h',
        'browser/ui/autofill/tab_autofill_manager_delegate.cc',
        'browser/ui/autofill/tab_autofill_manager_delegate.h',
        'browser/ui/auto_login_info_bar_delegate.cc',
        'browser/ui/auto_login_info_bar_delegate.h',
        'browser/ui/auto_login_prompter.cc',
        'browser/ui/auto_login_prompter.h',
        'browser/ui/base_window.h',
        'browser/ui/blocked_content/blocked_content_container.cc',
        'browser/ui/blocked_content/blocked_content_container.h',
        'browser/ui/blocked_content/blocked_content_tab_helper.cc',
        'browser/ui/blocked_content/blocked_content_tab_helper.h',
        'browser/ui/blocked_content/blocked_content_tab_helper_delegate.cc',
        'browser/ui/blocked_content/blocked_content_tab_helper_delegate.h',
        'browser/ui/bookmarks/bookmark_bar.h',
        'browser/ui/bookmarks/bookmark_bar_constants.h',
        'browser/ui/bookmarks/bookmark_bar_instructions_delegate.h',
        'browser/ui/bookmarks/bookmark_context_menu_controller.cc',
        'browser/ui/bookmarks/bookmark_context_menu_controller.h',
        'browser/ui/bookmarks/bookmark_tab_helper.cc',
        'browser/ui/bookmarks/bookmark_tab_helper.h',
        'browser/ui/bookmarks/bookmark_tab_helper_delegate.cc',
        'browser/ui/bookmarks/bookmark_tab_helper_delegate.h',
        'browser/ui/bookmarks/bookmark_utils.cc',
        'browser/ui/bookmarks/bookmark_utils.h',
        'browser/ui/browser.cc',
        'browser/ui/browser.h',
        'browser/ui/browser_adoption.cc',
        'browser/ui/browser_commands.cc',
        'browser/ui/browser_commands.h',
        'browser/ui/browser_command_controller.cc',
        'browser/ui/browser_command_controller.h',
        'browser/ui/browser_content_setting_bubble_model_delegate.cc',
        'browser/ui/browser_content_setting_bubble_model_delegate.h',
        'browser/ui/browser_dialogs.h',
        'browser/ui/browser_finder.cc',
        'browser/ui/browser_finder.h',
        'browser/ui/browser_instant_controller.cc',
        'browser/ui/browser_instant_controller.h',
        'browser/ui/browser_list.cc',
        'browser/ui/browser_list.h',
        'browser/ui/browser_list_impl.cc',
        'browser/ui/browser_list_impl.h',
        'browser/ui/browser_mac.cc',
        'browser/ui/browser_mac.h',
        'browser/ui/browser_navigator.cc',
        'browser/ui/browser_navigator.h',
        'browser/ui/browser_otr_state_android.cc',
        'browser/ui/browser_otr_state.cc',
        'browser/ui/browser_otr_state.h',
        'browser/ui/browser_ui_prefs.cc',
        'browser/ui/browser_ui_prefs.h',
        'browser/ui/browser_tab_restore_service_delegate.cc',
        'browser/ui/browser_tab_restore_service_delegate.h',
        'browser/ui/browser_tab_strip_model_delegate.cc',
        'browser/ui/browser_tab_strip_model_delegate.h',
        'browser/ui/browser_tabrestore.cc',
        'browser/ui/browser_tabrestore.h',
        'browser/ui/browser_tabstrip.cc',
        'browser/ui/browser_tabstrip.h',
        'browser/ui/browser_toolbar_model_delegate.cc',
        'browser/ui/browser_toolbar_model_delegate.h',
        'browser/ui/browser_view_prefs.cc',
        'browser/ui/browser_view_prefs.h',
        'browser/ui/browser_win.cc',
        'browser/ui/browser_window.h',
        'browser/ui/browser_window_state.cc',
        'browser/ui/browser_window_state.h',
        'browser/ui/certificate_dialogs.cc',
        'browser/ui/certificate_dialogs.h',
        'browser/ui/chrome_pages.cc',
        'browser/ui/chrome_pages.h',
        'browser/ui/chrome_select_file_policy.cc',
        'browser/ui/chrome_select_file_policy.h',
        'browser/ui/cocoa/about_ipc_controller.h',
        'browser/ui/cocoa/about_ipc_controller.mm',
        'browser/ui/cocoa/about_ipc_dialog.h',
        'browser/ui/cocoa/about_ipc_dialog.mm',
        'browser/ui/cocoa/accelerators_cocoa.h',
        'browser/ui/cocoa/accelerators_cocoa.mm',
        'browser/ui/cocoa/animatable_image.h',
        'browser/ui/cocoa/animatable_image.mm',
        'browser/ui/cocoa/animatable_view.h',
        'browser/ui/cocoa/animatable_view.mm',
        'browser/ui/cocoa/applescript/bookmark_folder_applescript.h',
        'browser/ui/cocoa/applescript/bookmark_folder_applescript.mm',
        'browser/ui/cocoa/applescript/bookmark_item_applescript.h',
        'browser/ui/cocoa/applescript/bookmark_item_applescript.mm',
        'browser/ui/cocoa/applescript/bookmark_node_applescript.h',
        'browser/ui/cocoa/applescript/bookmark_node_applescript.mm',
        'browser/ui/cocoa/applescript/browsercrapplication+applescript.h',
        'browser/ui/cocoa/applescript/browsercrapplication+applescript.mm',
        'browser/ui/cocoa/applescript/constants_applescript.h',
        'browser/ui/cocoa/applescript/constants_applescript.mm',
        'browser/ui/cocoa/applescript/element_applescript.h',
        'browser/ui/cocoa/applescript/element_applescript.mm',
        'browser/ui/cocoa/applescript/error_applescript.h',
        'browser/ui/cocoa/applescript/error_applescript.mm',
        'browser/ui/cocoa/applescript/tab_applescript.h',
        'browser/ui/cocoa/applescript/tab_applescript.mm',
        'browser/ui/cocoa/applescript/window_applescript.h',
        'browser/ui/cocoa/applescript/window_applescript.mm',
        'browser/ui/cocoa/background_gradient_view.h',
        'browser/ui/cocoa/background_gradient_view.mm',
        'browser/ui/cocoa/background_tile_view.h',
        'browser/ui/cocoa/background_tile_view.mm',
        'browser/ui/cocoa/base_bubble_controller.h',
        'browser/ui/cocoa/base_bubble_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_all_tabs_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_all_tabs_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_bridge.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_bridge.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_constants.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_button_cell.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_button_cell.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_hover_state.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_hover_state.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_view.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_view.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_window.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_folder_window.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_state.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_toolbar_view.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_toolbar_view.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bar_view.h',
        'browser/ui/cocoa/bookmarks/bookmark_bar_view.mm',
        'browser/ui/cocoa/bookmarks/bookmark_bubble_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_bubble_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_button.h',
        'browser/ui/cocoa/bookmarks/bookmark_button.mm',
        'browser/ui/cocoa/bookmarks/bookmark_button_cell.h',
        'browser/ui/cocoa/bookmarks/bookmark_button_cell.mm',
        'browser/ui/cocoa/bookmarks/bookmark_editor_base_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_editor_base_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_editor_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_editor_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_folder_target.h',
        'browser/ui/cocoa/bookmarks/bookmark_folder_target.mm',
        'browser/ui/cocoa/bookmarks/bookmark_menu.h',
        'browser/ui/cocoa/bookmarks/bookmark_menu.mm',
        'browser/ui/cocoa/bookmarks/bookmark_menu_bridge.h',
        'browser/ui/cocoa/bookmarks/bookmark_menu_bridge.mm',
        'browser/ui/cocoa/bookmarks/bookmark_menu_cocoa_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_menu_cocoa_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_model_observer_for_cocoa.h',
        'browser/ui/cocoa/bookmarks/bookmark_model_observer_for_cocoa.mm',
        'browser/ui/cocoa/bookmarks/bookmark_name_folder_controller.h',
        'browser/ui/cocoa/bookmarks/bookmark_name_folder_controller.mm',
        'browser/ui/cocoa/bookmarks/bookmark_tree_browser_cell.h',
        'browser/ui/cocoa/bookmarks/bookmark_tree_browser_cell.mm',
        'browser/ui/cocoa/browser/avatar_button_controller.h',
        'browser/ui/cocoa/browser/avatar_button_controller.mm',
        'browser/ui/cocoa/browser/avatar_menu_bubble_controller.h',
        'browser/ui/cocoa/browser/avatar_menu_bubble_controller.mm',
        'browser/ui/cocoa/browser/edit_search_engine_cocoa_controller.h',
        'browser/ui/cocoa/browser/edit_search_engine_cocoa_controller.mm',
        'browser/ui/cocoa/browser_command_executor.h',
        'browser/ui/cocoa/browser_window_cocoa.h',
        'browser/ui/cocoa/browser_window_cocoa.mm',
        'browser/ui/cocoa/browser_window_controller.h',
        'browser/ui/cocoa/browser_window_controller.mm',
        'browser/ui/cocoa/browser_window_controller_private.h',
        'browser/ui/cocoa/browser_window_controller_private.mm',
        'browser/ui/cocoa/browser_window_factory.mm',
        'browser/ui/cocoa/browser_window_utils.h',
        'browser/ui/cocoa/browser_window_utils.mm',
        'browser/ui/cocoa/bubble_view.h',
        'browser/ui/cocoa/bubble_view.mm',
        'browser/ui/cocoa/certificate_viewer_mac.mm',
        'browser/ui/cocoa/chrome_browser_window.h',
        'browser/ui/cocoa/chrome_browser_window.mm',
        'browser/ui/cocoa/chrome_event_processing_window.h',
        'browser/ui/cocoa/chrome_event_processing_window.mm',
        'browser/ui/cocoa/chrome_to_mobile_bubble_controller.h',
        'browser/ui/cocoa/chrome_to_mobile_bubble_controller.mm',
        'browser/ui/cocoa/clickhold_button_cell.h',
        'browser/ui/cocoa/clickhold_button_cell.mm',
        'browser/ui/cocoa/color_chooser_mac.mm',
        'browser/ui/cocoa/command_observer_bridge.h',
        'browser/ui/cocoa/command_observer_bridge.mm',
        'browser/ui/cocoa/confirm_bubble_cocoa.h',
        'browser/ui/cocoa/confirm_bubble_cocoa.mm',
        'browser/ui/cocoa/confirm_bubble_controller.h',
        'browser/ui/cocoa/confirm_bubble_controller.mm',
        'browser/ui/cocoa/confirm_quit.h',
        'browser/ui/cocoa/confirm_quit_panel_controller.h',
        'browser/ui/cocoa/confirm_quit_panel_controller.mm',
        'browser/ui/cocoa/constrained_web_dialog_delegate_mac.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_alert.h',
        'browser/ui/cocoa/constrained_window/constrained_window_alert.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_animation.h',
        'browser/ui/cocoa/constrained_window/constrained_window_animation.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_button.h',
        'browser/ui/cocoa/constrained_window/constrained_window_button.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_control_utils.h',
        'browser/ui/cocoa/constrained_window/constrained_window_control_utils.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_custom_window.h',
        'browser/ui/cocoa/constrained_window/constrained_window_custom_window.h',
        'browser/ui/cocoa/constrained_window/constrained_window_custom_window.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_mac2.h',
        'browser/ui/cocoa/constrained_window/constrained_window_mac2.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_sheet_controller.h',
        'browser/ui/cocoa/constrained_window/constrained_window_sheet_controller.mm',
        'browser/ui/cocoa/constrained_window/constrained_window_sheet_info.h',
        'browser/ui/cocoa/constrained_window/constrained_window_sheet_info.mm',
        'browser/ui/cocoa/constrained_window_mac.h',
        'browser/ui/cocoa/constrained_window_mac.mm',
        'browser/ui/cocoa/content_settings/collected_cookies_mac.h',
        'browser/ui/cocoa/content_settings/collected_cookies_mac.mm',
        'browser/ui/cocoa/content_settings/content_setting_bubble_cocoa.h',
        'browser/ui/cocoa/content_settings/content_setting_bubble_cocoa.mm',
        'browser/ui/cocoa/content_settings/cookie_details.h',
        'browser/ui/cocoa/content_settings/cookie_details.mm',
        'browser/ui/cocoa/content_settings/cookie_details_view_controller.h',
        'browser/ui/cocoa/content_settings/cookie_details_view_controller.mm',
        'browser/ui/cocoa/content_settings/cookie_tree_node.h',
        'browser/ui/cocoa/content_settings/cookie_tree_node.mm',
        'browser/ui/cocoa/custom_frame_view.h',
        'browser/ui/cocoa/custom_frame_view.mm',
        'browser/ui/cocoa/dev_tools_controller.h',
        'browser/ui/cocoa/dev_tools_controller.mm',
        'browser/ui/cocoa/dock_icon.h',
        'browser/ui/cocoa/dock_icon.mm',
        'browser/ui/cocoa/download/background_theme.h',
        'browser/ui/cocoa/download/background_theme.mm',
        'browser/ui/cocoa/download/download_item_button.h',
        'browser/ui/cocoa/download/download_item_button.mm',
        'browser/ui/cocoa/download/download_item_cell.h',
        'browser/ui/cocoa/download/download_item_cell.mm',
        'browser/ui/cocoa/download/download_item_controller.h',
        'browser/ui/cocoa/download/download_item_controller.mm',
        'browser/ui/cocoa/download/download_item_mac.h',
        'browser/ui/cocoa/download/download_item_mac.mm',
        'browser/ui/cocoa/download/download_shelf_controller.h',
        'browser/ui/cocoa/download/download_shelf_controller.mm',
        'browser/ui/cocoa/download/download_shelf_mac.h',
        'browser/ui/cocoa/download/download_shelf_mac.mm',
        'browser/ui/cocoa/download/download_shelf_view.h',
        'browser/ui/cocoa/download/download_shelf_view.mm',
        'browser/ui/cocoa/download/download_show_all_button.h',
        'browser/ui/cocoa/download/download_show_all_button.mm',
        'browser/ui/cocoa/download/download_show_all_cell.h',
        'browser/ui/cocoa/download/download_show_all_cell.mm',
        'browser/ui/cocoa/download/download_started_animation_mac.mm',
        'browser/ui/cocoa/download/download_util_mac.h',
        'browser/ui/cocoa/download/download_util_mac.mm',
        'browser/ui/cocoa/draggable_button.h',
        'browser/ui/cocoa/draggable_button.mm',
        'browser/ui/cocoa/draggable_button_mixin.h',
        'browser/ui/cocoa/draggable_button_mixin.mm',
        'browser/ui/cocoa/drag_util.h',
        'browser/ui/cocoa/drag_util.mm',
        'browser/ui/cocoa/encoding_menu_controller_delegate_mac.h',
        'browser/ui/cocoa/encoding_menu_controller_delegate_mac.mm',
        'browser/ui/cocoa/event_utils.h',
        'browser/ui/cocoa/event_utils.mm',
        'browser/ui/cocoa/extensions/browser_action_button.h',
        'browser/ui/cocoa/extensions/browser_action_button.mm',
        'browser/ui/cocoa/extensions/browser_actions_container_view.h',
        'browser/ui/cocoa/extensions/browser_actions_container_view.mm',
        'browser/ui/cocoa/extensions/browser_actions_controller.h',
        'browser/ui/cocoa/extensions/browser_actions_controller.mm',
        'browser/ui/cocoa/extensions/extension_action_context_menu.h',
        'browser/ui/cocoa/extensions/extension_action_context_menu.mm',
        'browser/ui/cocoa/extensions/extension_install_dialog_controller.h',
        'browser/ui/cocoa/extensions/extension_install_dialog_controller.mm',
        'browser/ui/cocoa/extensions/extension_install_view_controller.h',
        'browser/ui/cocoa/extensions/extension_install_view_controller.mm',
        'browser/ui/cocoa/extensions/extension_installed_bubble_bridge.mm',
        'browser/ui/cocoa/extensions/extension_installed_bubble_controller.h',
        'browser/ui/cocoa/extensions/extension_installed_bubble_controller.mm',
        'browser/ui/cocoa/extensions/extension_keybinding_registry_cocoa.h',
        'browser/ui/cocoa/extensions/extension_keybinding_registry_cocoa.mm',
        'browser/ui/cocoa/extensions/extension_popup_controller.h',
        'browser/ui/cocoa/extensions/extension_popup_controller.mm',
        'browser/ui/cocoa/extensions/extension_uninstall_dialog_cocoa.mm',
        'browser/ui/cocoa/extensions/extension_view_mac.h',
        'browser/ui/cocoa/extensions/extension_view_mac.mm',
        'browser/ui/cocoa/extensions/media_galleries_dialog_cocoa.h',
        'browser/ui/cocoa/extensions/media_galleries_dialog_cocoa.mm',
        'browser/ui/cocoa/extensions/shell_window_cocoa.h',
        'browser/ui/cocoa/extensions/shell_window_cocoa.mm',
        'browser/ui/cocoa/external_protocol_dialog.h',
        'browser/ui/cocoa/external_protocol_dialog.mm',
        'browser/ui/cocoa/fast_resize_view.h',
        'browser/ui/cocoa/fast_resize_view.mm',
        'browser/ui/cocoa/find_bar/find_bar_bridge.h',
        'browser/ui/cocoa/find_bar/find_bar_bridge.mm',
        'browser/ui/cocoa/find_bar/find_bar_cocoa_controller.h',
        'browser/ui/cocoa/find_bar/find_bar_cocoa_controller.mm',
        'browser/ui/cocoa/find_bar/find_bar_text_field.h',
        'browser/ui/cocoa/find_bar/find_bar_text_field.mm',
        'browser/ui/cocoa/find_bar/find_bar_text_field_cell.h',
        'browser/ui/cocoa/find_bar/find_bar_text_field_cell.mm',
        'browser/ui/cocoa/find_bar/find_bar_view.h',
        'browser/ui/cocoa/find_bar/find_bar_view.mm',
        'browser/ui/cocoa/first_run_bubble_controller.h',
        'browser/ui/cocoa/first_run_bubble_controller.mm',
        'browser/ui/cocoa/first_run_dialog.h',
        'browser/ui/cocoa/first_run_dialog.mm',
        'browser/ui/cocoa/flipped_view.h',
        'browser/ui/cocoa/flipped_view.mm',
        'browser/ui/cocoa/floating_bar_backing_view.h',
        'browser/ui/cocoa/floating_bar_backing_view.mm',
        'browser/ui/cocoa/framed_browser_window.h',
        'browser/ui/cocoa/framed_browser_window.mm',
        'browser/ui/cocoa/fullscreen_exit_bubble_controller.h',
        'browser/ui/cocoa/fullscreen_exit_bubble_controller.mm',
        'browser/ui/cocoa/fullscreen_exit_bubble_view.h',
        'browser/ui/cocoa/fullscreen_exit_bubble_view.mm',
        'browser/ui/cocoa/fullscreen_window.h',
        'browser/ui/cocoa/fullscreen_window.mm',
        'browser/ui/cocoa/global_error_bubble_controller.h',
        'browser/ui/cocoa/global_error_bubble_controller.mm',
        'browser/ui/cocoa/gradient_button_cell.h',
        'browser/ui/cocoa/gradient_button_cell.mm',
        'browser/ui/cocoa/history_menu_bridge.h',
        'browser/ui/cocoa/history_menu_bridge.mm',
        'browser/ui/cocoa/history_menu_cocoa_controller.h',
        'browser/ui/cocoa/history_menu_cocoa_controller.mm',
        'browser/ui/cocoa/history_overlay_controller.h',
        'browser/ui/cocoa/history_overlay_controller.mm',
        'browser/ui/cocoa/hover_button.h',
        'browser/ui/cocoa/hover_button.mm',
        'browser/ui/cocoa/hover_close_button.h',
        'browser/ui/cocoa/hover_close_button.mm',
        'browser/ui/cocoa/hover_image_button.h',
        'browser/ui/cocoa/hover_image_button.mm',
        'browser/ui/cocoa/hung_renderer_controller.h',
        'browser/ui/cocoa/hung_renderer_controller.mm',
        'browser/ui/cocoa/hyperlink_button_cell.h',
        'browser/ui/cocoa/hyperlink_button_cell.mm',
        'browser/ui/cocoa/hyperlink_text_view.h',
        'browser/ui/cocoa/hyperlink_text_view.mm',
        'browser/ui/cocoa/image_button_cell.h',
        'browser/ui/cocoa/image_button_cell.mm',
        'browser/ui/cocoa/importer/import_lock_dialog_cocoa.mm',
        'browser/ui/cocoa/importer/import_progress_dialog_cocoa.h',
        'browser/ui/cocoa/importer/import_progress_dialog_cocoa.mm',
        'browser/ui/cocoa/info_bubble_view.h',
        'browser/ui/cocoa/info_bubble_view.mm',
        'browser/ui/cocoa/info_bubble_window.h',
        'browser/ui/cocoa/info_bubble_window.mm',
        'browser/ui/cocoa/infobars/after_translate_infobar_controller.h',
        'browser/ui/cocoa/infobars/after_translate_infobar_controller.mm',
        'browser/ui/cocoa/infobars/before_translate_infobar_controller.h',
        'browser/ui/cocoa/infobars/before_translate_infobar_controller.mm',
        'browser/ui/cocoa/infobars/extension_infobar_controller.h',
        'browser/ui/cocoa/infobars/extension_infobar_controller.mm',
        'browser/ui/cocoa/infobars/infobar_container_controller.h',
        'browser/ui/cocoa/infobars/infobar_container_controller.mm',
        'browser/ui/cocoa/infobars/infobar_controller.h',
        'browser/ui/cocoa/infobars/infobar_controller.mm',
        'browser/ui/cocoa/infobars/infobar_gradient_view.h',
        'browser/ui/cocoa/infobars/infobar_gradient_view.mm',
        'browser/ui/cocoa/infobars/infobar_utilities.h',
        'browser/ui/cocoa/infobars/infobar_utilities.mm',
        'browser/ui/cocoa/infobars/infobar.h',
        'browser/ui/cocoa/infobars/media_stream_infobar_controller.h',
        'browser/ui/cocoa/infobars/media_stream_infobar_controller.mm',
        'browser/ui/cocoa/infobars/mock_confirm_infobar_delegate.cc',
        'browser/ui/cocoa/infobars/mock_confirm_infobar_delegate.h',
        'browser/ui/cocoa/infobars/mock_link_infobar_delegate.cc',
        'browser/ui/cocoa/infobars/mock_link_infobar_delegate.h',
        'browser/ui/cocoa/infobars/translate_infobar_base.h',
        'browser/ui/cocoa/infobars/translate_infobar_base.mm',
        'browser/ui/cocoa/infobars/translate_message_infobar_controller.h',
        'browser/ui/cocoa/infobars/translate_message_infobar_controller.mm',
        'browser/ui/cocoa/intents/web_intent_choose_service_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_choose_service_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_extension_prompt_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_extension_prompt_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_inline_service_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_inline_service_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_message_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_message_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_picker_cocoa2.h',
        'browser/ui/cocoa/intents/web_intent_picker_cocoa2.mm',
        'browser/ui/cocoa/intents/web_intent_picker_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_picker_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_progress_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_progress_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_service_row_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_service_row_view_controller.mm',
        'browser/ui/cocoa/intents/web_intent_view_controller.h',
        'browser/ui/cocoa/intents/web_intent_view_controller.mm',
        'browser/ui/cocoa/javascript_app_modal_dialog_cocoa.h',
        'browser/ui/cocoa/javascript_app_modal_dialog_cocoa.mm',
        'browser/ui/cocoa/key_equivalent_constants.h',
        'browser/ui/cocoa/key_equivalent_constants.mm',
        'browser/ui/cocoa/keystone_infobar_delegate.h',
        'browser/ui/cocoa/keystone_infobar_delegate.mm',
        'browser/ui/cocoa/l10n_util.h',
        'browser/ui/cocoa/l10n_util.mm',
        'browser/ui/cocoa/last_active_browser_cocoa.cc',
        'browser/ui/cocoa/last_active_browser_cocoa.h',
        'browser/ui/cocoa/location_bar/action_box_menu_bubble_controller.h',
        'browser/ui/cocoa/location_bar/action_box_menu_bubble_controller.mm',
        'browser/ui/cocoa/location_bar/autocomplete_text_field.h',
        'browser/ui/cocoa/location_bar/autocomplete_text_field.mm',
        'browser/ui/cocoa/location_bar/autocomplete_text_field_cell.h',
        'browser/ui/cocoa/location_bar/autocomplete_text_field_cell.mm',
        'browser/ui/cocoa/location_bar/autocomplete_text_field_editor.h',
        'browser/ui/cocoa/location_bar/autocomplete_text_field_editor.mm',
        'browser/ui/cocoa/location_bar/bubble_decoration.h',
        'browser/ui/cocoa/location_bar/bubble_decoration.mm',
        'browser/ui/cocoa/location_bar/button_decoration.h',
        'browser/ui/cocoa/location_bar/button_decoration.mm',
        'browser/ui/cocoa/location_bar/content_setting_decoration.h',
        'browser/ui/cocoa/location_bar/content_setting_decoration.mm',
        'browser/ui/cocoa/location_bar/ev_bubble_decoration.h',
        'browser/ui/cocoa/location_bar/ev_bubble_decoration.mm',
        'browser/ui/cocoa/location_bar/image_decoration.h',
        'browser/ui/cocoa/location_bar/image_decoration.mm',
        'browser/ui/cocoa/location_bar/keyword_hint_decoration.h',
        'browser/ui/cocoa/location_bar/keyword_hint_decoration.mm',
        'browser/ui/cocoa/location_bar/location_bar_decoration.h',
        'browser/ui/cocoa/location_bar/location_bar_decoration.mm',
        'browser/ui/cocoa/location_bar/location_bar_view_mac.h',
        'browser/ui/cocoa/location_bar/location_bar_view_mac.mm',
        'browser/ui/cocoa/location_bar/location_icon_decoration.h',
        'browser/ui/cocoa/location_bar/location_icon_decoration.mm',
        'browser/ui/cocoa/location_bar/page_action_decoration.h',
        'browser/ui/cocoa/location_bar/page_action_decoration.mm',
        'browser/ui/cocoa/location_bar/plus_decoration.h',
        'browser/ui/cocoa/location_bar/plus_decoration.mm',
        'browser/ui/cocoa/location_bar/selected_keyword_decoration.h',
        'browser/ui/cocoa/location_bar/selected_keyword_decoration.mm',
        'browser/ui/cocoa/location_bar/star_decoration.h',
        'browser/ui/cocoa/location_bar/star_decoration.mm',
        'browser/ui/cocoa/location_bar/web_intents_button_decoration.h',
        'browser/ui/cocoa/location_bar/web_intents_button_decoration.mm',
        'browser/ui/cocoa/location_bar/zoom_decoration.h',
        'browser/ui/cocoa/location_bar/zoom_decoration.mm',
        'browser/ui/cocoa/login_prompt_cocoa.h',
        'browser/ui/cocoa/login_prompt_cocoa.mm',
        'browser/ui/cocoa/main_menu_item.h',
        'browser/ui/cocoa/menu_button.h',
        'browser/ui/cocoa/menu_button.mm',
        'browser/ui/cocoa/menu_controller.h',
        'browser/ui/cocoa/menu_controller.mm',
        'browser/ui/cocoa/multi_key_equivalent_button.h',
        'browser/ui/cocoa/multi_key_equivalent_button.mm',
        'browser/ui/cocoa/new_tab_button.h',
        'browser/ui/cocoa/new_tab_button.mm',
        'browser/ui/cocoa/notifications/balloon_collection_cocoa.mm',
        'browser/ui/cocoa/notifications/balloon_controller.h',
        'browser/ui/cocoa/notifications/balloon_controller.mm',
        'browser/ui/cocoa/notifications/balloon_view.h',
        'browser/ui/cocoa/notifications/balloon_view.mm',
        'browser/ui/cocoa/notifications/balloon_view_bridge.h',
        'browser/ui/cocoa/notifications/balloon_view_bridge.mm',
        'browser/ui/cocoa/notifications/balloon_view_host_mac.h',
        'browser/ui/cocoa/notifications/balloon_view_host_mac.mm',
        'browser/ui/cocoa/nsmenuitem_additions.h',
        'browser/ui/cocoa/nsmenuitem_additions.mm',
        'browser/ui/cocoa/nsview_additions.h',
        'browser/ui/cocoa/nsview_additions.mm',
        'browser/ui/cocoa/omnibox/omnibox_popup_view_mac.h',
        'browser/ui/cocoa/omnibox/omnibox_popup_view_mac.mm',
        'browser/ui/cocoa/omnibox/omnibox_view_mac.h',
        'browser/ui/cocoa/omnibox/omnibox_view_mac.mm',
        'browser/ui/cocoa/one_click_signin_bubble_controller.h',
        'browser/ui/cocoa/one_click_signin_bubble_controller.mm',
        'browser/ui/cocoa/other_device_menu_cocoa.h',
        'browser/ui/cocoa/other_device_menu_cocoa.mm',
        'browser/ui/cocoa/page_info_bubble_controller.h',
        'browser/ui/cocoa/page_info_bubble_controller.mm',
        'browser/ui/cocoa/panels/display_settings_provider_cocoa.mm',
        'browser/ui/cocoa/panels/mouse_drag_controller.h',
        'browser/ui/cocoa/panels/mouse_drag_controller.mm',
        'browser/ui/cocoa/panels/panel_cocoa.h',
        'browser/ui/cocoa/panels/panel_cocoa.mm',
        'browser/ui/cocoa/panels/panel_titlebar_view_cocoa.h',
        'browser/ui/cocoa/panels/panel_titlebar_view_cocoa.mm',
        'browser/ui/cocoa/panels/panel_utils_cocoa.h',
        'browser/ui/cocoa/panels/panel_utils_cocoa.mm',
        'browser/ui/cocoa/panels/panel_window_controller_cocoa.h',
        'browser/ui/cocoa/panels/panel_window_controller_cocoa.mm',
        'browser/ui/cocoa/presentation_mode_controller.h',
        'browser/ui/cocoa/presentation_mode_controller.mm',
        'browser/ui/cocoa/profile_menu_controller.h',
        'browser/ui/cocoa/profile_menu_controller.mm',
        'browser/ui/cocoa/ratings_view.h',
        'browser/ui/cocoa/ratings_view.mm',
        'browser/ui/cocoa/restart_browser.h',
        'browser/ui/cocoa/restart_browser.mm',
        'browser/ui/cocoa/simple_message_box_mac.mm',
        'browser/ui/cocoa/speech_recognition_bubble_cocoa.mm',
        'browser/ui/cocoa/speech_recognition_window_controller.h',
        'browser/ui/cocoa/speech_recognition_window_controller.mm',
        'browser/ui/cocoa/spinner_progress_indicator.h',
        'browser/ui/cocoa/spinner_progress_indicator.mm',
        'browser/ui/cocoa/ssl_client_certificate_selector.mm',
        'browser/ui/cocoa/status_bubble_mac.h',
        'browser/ui/cocoa/status_bubble_mac.mm',
        'browser/ui/cocoa/status_icons/status_icon_mac.h',
        'browser/ui/cocoa/status_icons/status_icon_mac.mm',
        'browser/ui/cocoa/status_icons/status_tray_mac.h',
        'browser/ui/cocoa/status_icons/status_tray_mac.mm',
        'browser/ui/cocoa/styled_text_field.h',
        'browser/ui/cocoa/styled_text_field.mm',
        'browser/ui/cocoa/styled_text_field_cell.h',
        'browser/ui/cocoa/styled_text_field_cell.mm',
        'browser/ui/cocoa/tab_contents/chrome_web_contents_view_delegate_mac.h',
        'browser/ui/cocoa/tab_contents/chrome_web_contents_view_delegate_mac.mm',
        'browser/ui/cocoa/tab_contents/render_view_context_menu_mac.h',
        'browser/ui/cocoa/tab_contents/render_view_context_menu_mac.mm',
        'browser/ui/cocoa/tab_contents/favicon_util_mac.h',
        'browser/ui/cocoa/tab_contents/favicon_util_mac.mm',
        'browser/ui/cocoa/tab_contents/instant_preview_controller_mac.h',
        'browser/ui/cocoa/tab_contents/instant_preview_controller_mac.mm',
        'browser/ui/cocoa/tab_contents/previewable_contents_controller.h',
        'browser/ui/cocoa/tab_contents/previewable_contents_controller.mm',
        'browser/ui/cocoa/tab_contents/sad_tab_controller.h',
        'browser/ui/cocoa/tab_contents/sad_tab_controller.mm',
        'browser/ui/cocoa/tab_contents/sad_tab_view.h',
        'browser/ui/cocoa/tab_contents/sad_tab_view.mm',
        'browser/ui/cocoa/tab_contents/tab_contents_controller.h',
        'browser/ui/cocoa/tab_contents/tab_contents_controller.mm',
        'browser/ui/cocoa/tab_modal_confirm_dialog_mac.h',
        'browser/ui/cocoa/tab_modal_confirm_dialog_mac.mm',
        'browser/ui/cocoa/tab_view_picker_table.h',
        'browser/ui/cocoa/tab_view_picker_table.mm',
        'browser/ui/cocoa/table_row_nsimage_cache.h',
        'browser/ui/cocoa/table_row_nsimage_cache.mm',
        'browser/ui/cocoa/tabpose_window.h',
        'browser/ui/cocoa/tabpose_window.mm',
        'browser/ui/cocoa/tabs/dock_info_mac.cc',
        'browser/ui/cocoa/tabs/tab_controller.h',
        'browser/ui/cocoa/tabs/tab_controller.mm',
        'browser/ui/cocoa/tabs/tab_strip_controller.h',
        'browser/ui/cocoa/tabs/tab_strip_controller.mm',
        'browser/ui/cocoa/tabs/tab_strip_drag_controller.h',
        'browser/ui/cocoa/tabs/tab_strip_drag_controller.mm',
        'browser/ui/cocoa/tabs/tab_strip_model_observer_bridge.h',
        'browser/ui/cocoa/tabs/tab_strip_model_observer_bridge.mm',
        'browser/ui/cocoa/tabs/tab_strip_view.h',
        'browser/ui/cocoa/tabs/tab_strip_view.mm',
        'browser/ui/cocoa/tabs/tab_view.h',
        'browser/ui/cocoa/tabs/tab_view.mm',
        'browser/ui/cocoa/tabs/tab_window_controller.h',
        'browser/ui/cocoa/tabs/tab_window_controller.mm',
        'browser/ui/cocoa/tabs/throbber_view.h',
        'browser/ui/cocoa/tabs/throbber_view.mm',
        'browser/ui/cocoa/task_manager_mac.h',
        'browser/ui/cocoa/task_manager_mac.mm',
        'browser/ui/cocoa/themed_window.h',
        'browser/ui/cocoa/themed_window.mm',
        'browser/ui/cocoa/toolbar/back_forward_menu_controller.h',
        'browser/ui/cocoa/toolbar/back_forward_menu_controller.mm',
        'browser/ui/cocoa/toolbar/reload_button.h',
        'browser/ui/cocoa/toolbar/reload_button.mm',
        'browser/ui/cocoa/toolbar/toolbar_button.h',
        'browser/ui/cocoa/toolbar/toolbar_button.mm',
        'browser/ui/cocoa/toolbar/toolbar_controller.h',
        'browser/ui/cocoa/toolbar/toolbar_controller.mm',
        'browser/ui/cocoa/toolbar/toolbar_view.h',
        'browser/ui/cocoa/toolbar/toolbar_view.mm',
        'browser/ui/cocoa/tracking_area.h',
        'browser/ui/cocoa/tracking_area.mm',
        'browser/ui/cocoa/ui_localizer.h',
        'browser/ui/cocoa/ui_localizer.mm',
        'browser/ui/cocoa/url_drop_target.h',
        'browser/ui/cocoa/url_drop_target.mm',
        'browser/ui/cocoa/vertical_gradient_view.h',
        'browser/ui/cocoa/vertical_gradient_view.mm',
        'browser/ui/cocoa/view_id_util.h',
        'browser/ui/cocoa/view_id_util.mm',
        'browser/ui/cocoa/view_resizer.h',
        'browser/ui/cocoa/web_dialog_window_controller.h',
        'browser/ui/cocoa/web_dialog_window_controller.mm',
        'browser/ui/cocoa/web_intent_sheet_controller.h',
        'browser/ui/cocoa/web_intent_sheet_controller.mm',
        'browser/ui/cocoa/web_intent_picker_cocoa.h',
        'browser/ui/cocoa/web_intent_picker_cocoa.mm',
        'browser/ui/cocoa/website_settings_bubble_controller.h',
        'browser/ui/cocoa/website_settings_bubble_controller.mm',
        'browser/ui/cocoa/window_restore_utils.h',
        'browser/ui/cocoa/window_restore_utils.mm',
        'browser/ui/cocoa/window_size_autosaver.h',
        'browser/ui/cocoa/window_size_autosaver.mm',
        'browser/ui/cocoa/wrench_menu/menu_tracked_button.h',
        'browser/ui/cocoa/wrench_menu/menu_tracked_button.mm',
        'browser/ui/cocoa/wrench_menu/menu_tracked_root_view.h',
        'browser/ui/cocoa/wrench_menu/menu_tracked_root_view.mm',
        'browser/ui/cocoa/wrench_menu/wrench_menu_button_cell.h',
        'browser/ui/cocoa/wrench_menu/wrench_menu_button_cell.mm',
        'browser/ui/cocoa/wrench_menu/wrench_menu_controller.h',
        'browser/ui/cocoa/wrench_menu/wrench_menu_controller.mm',
        'browser/ui/collected_cookies_infobar_delegate.cc',
        'browser/ui/collected_cookies_infobar_delegate.h',
        'browser/ui/confirm_bubble.h',
        'browser/ui/confirm_bubble_model.cc',
        'browser/ui/confirm_bubble_model.h',
        'browser/ui/content_settings/content_setting_bubble_model.cc',
        'browser/ui/content_settings/content_setting_bubble_model.h',
        'browser/ui/content_settings/content_setting_bubble_model_delegate.h',
        'browser/ui/content_settings/content_setting_image_model.cc',
        'browser/ui/content_settings/content_setting_image_model.h',
        'browser/ui/constrained_window.cc',
        'browser/ui/constrained_window.h',
        'browser/ui/constrained_window_constants.cc',
        'browser/ui/constrained_window_constants.h',
        'browser/ui/constrained_window_tab_helper.cc',
        'browser/ui/constrained_window_tab_helper.h',
        'browser/ui/constrained_window_tab_helper_delegate.cc',
        'browser/ui/constrained_window_tab_helper_delegate.h',
        'browser/ui/crypto_module_password_dialog.cc',
        'browser/ui/crypto_module_password_dialog.h',
        'browser/ui/crypto_module_password_dialog_nss.cc',
        'browser/ui/crypto_module_password_dialog_openssl.cc',
        'browser/ui/extensions/application_launch.cc',
        'browser/ui/extensions/application_launch.h',
        'browser/ui/extensions/native_shell_window.h',
        'browser/ui/extensions/shell_window.cc',
        'browser/ui/extensions/shell_window.h',
        'browser/ui/find_bar/find_bar.h',
        'browser/ui/find_bar/find_bar_controller.cc',
        'browser/ui/find_bar/find_bar_controller.h',
        'browser/ui/find_bar/find_bar_state.h',
        'browser/ui/find_bar/find_bar_state_factory.cc',
        'browser/ui/find_bar/find_bar_state_factory.h',
        'browser/ui/find_bar/find_notification_details.h',
        'browser/ui/find_bar/find_tab_helper.cc',
        'browser/ui/find_bar/find_tab_helper.h',
        'browser/ui/fullscreen/fullscreen_controller.cc',
        'browser/ui/fullscreen/fullscreen_controller.h',
        'browser/ui/fullscreen/fullscreen_exit_bubble.cc',
        'browser/ui/fullscreen/fullscreen_exit_bubble.h',
        'browser/ui/fullscreen/fullscreen_exit_bubble_type.cc',
        'browser/ui/fullscreen/fullscreen_exit_bubble_type.h',
        'browser/ui/gesture_prefs_observer_factory_aura.cc',
        'browser/ui/gesture_prefs_observer_factory_aura.h',
        'browser/ui/global_error/global_error.cc',
        'browser/ui/global_error/global_error.h',
        'browser/ui/global_error/global_error_bubble_view_base.h',
        'browser/ui/global_error/global_error_service.cc',
        'browser/ui/global_error/global_error_service.h',
        'browser/ui/global_error/global_error_service_factory.cc',
        'browser/ui/global_error/global_error_service_factory.h',
        'browser/ui/gtk/accelerators_gtk.cc',
        'browser/ui/gtk/accelerators_gtk.h',
        'browser/ui/gtk/action_box_button_gtk.cc',
        'browser/ui/gtk/action_box_button_gtk.h',
        'browser/ui/gtk/autofill/autofill_external_delegate_gtk.cc',
        'browser/ui/gtk/autofill/autofill_external_delegate_gtk.h',
        'browser/ui/gtk/autofill/autofill_popup_view_gtk.cc',
        'browser/ui/gtk/autofill/autofill_popup_view_gtk.h',
        'browser/ui/gtk/avatar_menu_bubble_gtk.cc',
        'browser/ui/gtk/avatar_menu_bubble_gtk.h',
        'browser/ui/gtk/avatar_menu_button_gtk.cc',
        'browser/ui/gtk/avatar_menu_button_gtk.h',
        'browser/ui/gtk/avatar_menu_item_gtk.cc',
        'browser/ui/gtk/avatar_menu_item_gtk.h',
        'browser/ui/gtk/back_forward_button_gtk.cc',
        'browser/ui/gtk/back_forward_button_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_bar_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_bar_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_bar_instructions_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_bar_instructions_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_bubble_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_bubble_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_editor_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_editor_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_menu_controller_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_menu_controller_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_sub_menu_model_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_sub_menu_model_gtk.h',
        'browser/ui/gtk/bookmarks/bookmark_tree_model.cc',
        'browser/ui/gtk/bookmarks/bookmark_tree_model.h',
        'browser/ui/gtk/bookmarks/bookmark_utils_gtk.cc',
        'browser/ui/gtk/bookmarks/bookmark_utils_gtk.h',
        'browser/ui/gtk/browser_actions_toolbar_gtk.cc',
        'browser/ui/gtk/browser_actions_toolbar_gtk.h',
        'browser/ui/gtk/browser_titlebar.cc',
        'browser/ui/gtk/browser_titlebar.h',
        'browser/ui/gtk/browser_toolbar_gtk.cc',
        'browser/ui/gtk/browser_toolbar_gtk.h',
        'browser/ui/gtk/browser_window_gtk.cc',
        'browser/ui/gtk/browser_window_gtk.h',
        'browser/ui/gtk/bubble/bubble_accelerators_gtk.cc',
        'browser/ui/gtk/bubble/bubble_accelerators_gtk.h',
        'browser/ui/gtk/bubble/bubble_gtk.cc',
        'browser/ui/gtk/bubble/bubble_gtk.h',
        'browser/ui/gtk/certificate_viewer_gtk.cc',
        'browser/ui/gtk/chrome_browser_main_extra_parts_gtk.cc',
        'browser/ui/gtk/chrome_browser_main_extra_parts_gtk.h',
        'browser/ui/gtk/chrome_gtk_frame.cc',
        'browser/ui/gtk/chrome_gtk_frame.h',
        'browser/ui/gtk/chrome_to_mobile_bubble_gtk.cc',
        'browser/ui/gtk/chrome_to_mobile_bubble_gtk.h',
        'browser/ui/gtk/collected_cookies_gtk.cc',
        'browser/ui/gtk/collected_cookies_gtk.h',
        'browser/ui/gtk/confirm_bubble_gtk.cc',
        'browser/ui/gtk/confirm_bubble_gtk.h',
        'browser/ui/gtk/color_chooser_gtk.cc',
        'browser/ui/gtk/constrained_web_dialog_delegate_gtk.cc',
        'browser/ui/gtk/constrained_window_gtk.cc',
        'browser/ui/gtk/constrained_window_gtk.h',
        'browser/ui/gtk/content_setting_bubble_gtk.cc',
        'browser/ui/gtk/content_setting_bubble_gtk.h',
        'browser/ui/gtk/create_application_shortcuts_dialog_gtk.cc',
        'browser/ui/gtk/create_application_shortcuts_dialog_gtk.h',
        'browser/ui/gtk/crypto_module_password_dialog_gtk.cc',
        'browser/ui/gtk/custom_button.cc',
        'browser/ui/gtk/custom_button.h',
        'browser/ui/gtk/custom_drag.cc',
        'browser/ui/gtk/custom_drag.h',
        'browser/ui/gtk/download/download_in_progress_dialog_gtk.cc',
        'browser/ui/gtk/download/download_in_progress_dialog_gtk.h',
        'browser/ui/gtk/download/download_item_gtk.cc',
        'browser/ui/gtk/download/download_item_gtk.h',
        'browser/ui/gtk/download/download_shelf_context_menu_gtk.cc',
        'browser/ui/gtk/download/download_shelf_context_menu_gtk.h',
        'browser/ui/gtk/download/download_shelf_gtk.cc',
        'browser/ui/gtk/download/download_shelf_gtk.h',
        'browser/ui/gtk/download/download_started_animation_gtk.cc',
        'browser/ui/gtk/edit_search_engine_dialog.cc',
        'browser/ui/gtk/edit_search_engine_dialog.h',
        'browser/ui/gtk/event_utils.cc',
        'browser/ui/gtk/event_utils.h',
        'browser/ui/gtk/extensions/bundle_installed_bubble_gtk.cc',
        'browser/ui/gtk/extensions/bundle_installed_bubble_gtk.h',
        'browser/ui/gtk/extensions/extension_install_dialog_gtk.cc',
        'browser/ui/gtk/extensions/extension_installed_bubble_gtk.cc',
        'browser/ui/gtk/extensions/extension_installed_bubble_gtk.h',
        'browser/ui/gtk/extensions/extension_keybinding_registry_gtk.cc',
        'browser/ui/gtk/extensions/extension_keybinding_registry_gtk.h',
        'browser/ui/gtk/extensions/extension_popup_gtk.cc',
        'browser/ui/gtk/extensions/extension_popup_gtk.h',
        'browser/ui/gtk/extensions/extension_uninstall_dialog_gtk.cc',
        'browser/ui/gtk/extensions/extension_view_gtk.cc',
        'browser/ui/gtk/extensions/extension_view_gtk.h',
        'browser/ui/gtk/extensions/media_galleries_dialog_gtk.cc',
        'browser/ui/gtk/extensions/media_galleries_dialog_gtk.h',
        'browser/ui/gtk/extensions/shell_window_gtk.cc',
        'browser/ui/gtk/extensions/shell_window_gtk.h',
        'browser/ui/gtk/external_protocol_dialog_gtk.cc',
        'browser/ui/gtk/external_protocol_dialog_gtk.h',
        'browser/ui/gtk/find_bar_gtk.cc',
        'browser/ui/gtk/find_bar_gtk.h',
        'browser/ui/gtk/first_run_bubble.cc',
        'browser/ui/gtk/first_run_bubble.h',
        'browser/ui/gtk/first_run_dialog.cc',
        'browser/ui/gtk/first_run_dialog.h',
        'browser/ui/gtk/fullscreen_exit_bubble_gtk.cc',
        'browser/ui/gtk/fullscreen_exit_bubble_gtk.h',
        'browser/ui/gtk/gconf_titlebar_listener.cc',
        'browser/ui/gtk/gconf_titlebar_listener.h',
        'browser/ui/gtk/global_error_bubble.cc',
        'browser/ui/gtk/global_error_bubble.h',
        'browser/ui/gtk/global_history_menu.cc',
        'browser/ui/gtk/global_history_menu.h',
        'browser/ui/gtk/global_menu_bar.cc',
        'browser/ui/gtk/global_menu_bar.h',
        'browser/ui/gtk/gtk_chrome_button.cc',
        'browser/ui/gtk/gtk_chrome_button.h',
        'browser/ui/gtk/gtk_chrome_cookie_view.cc',
        'browser/ui/gtk/gtk_chrome_cookie_view.h',
        'browser/ui/gtk/gtk_chrome_link_button.cc',
        'browser/ui/gtk/gtk_chrome_link_button.h',
        'browser/ui/gtk/gtk_chrome_shrinkable_hbox.cc',
        'browser/ui/gtk/gtk_chrome_shrinkable_hbox.h',
        'browser/ui/gtk/gtk_custom_menu.cc',
        'browser/ui/gtk/gtk_custom_menu.h',
        'browser/ui/gtk/gtk_custom_menu_item.cc',
        'browser/ui/gtk/gtk_custom_menu_item.h',
        'browser/ui/gtk/gtk_input_event_box.cc',
        'browser/ui/gtk/gtk_input_event_box.h',
        'browser/ui/gtk/gtk_theme_service.cc',
        'browser/ui/gtk/gtk_theme_service.h',
        'browser/ui/gtk/gtk_tree.cc',
        'browser/ui/gtk/gtk_tree.h',
        'browser/ui/gtk/gtk_util.cc',
        'browser/ui/gtk/gtk_util.h',
        'browser/ui/gtk/gtk_window_util.cc',
        'browser/ui/gtk/gtk_window_util.h',
        'browser/ui/gtk/hover_controller_gtk.cc',
        'browser/ui/gtk/hover_controller_gtk.h',
        'browser/ui/gtk/hung_renderer_dialog_gtk.cc',
        'browser/ui/gtk/importer/import_lock_dialog_gtk.cc',
        'browser/ui/gtk/importer/import_lock_dialog_gtk.h',
        'browser/ui/gtk/importer/import_progress_dialog_gtk.cc',
        'browser/ui/gtk/importer/import_progress_dialog_gtk.h',
        'browser/ui/gtk/infobars/after_translate_infobar_gtk.cc',
        'browser/ui/gtk/infobars/after_translate_infobar_gtk.h',
        'browser/ui/gtk/infobars/before_translate_infobar_gtk.cc',
        'browser/ui/gtk/infobars/before_translate_infobar_gtk.h',
        'browser/ui/gtk/infobars/confirm_infobar_gtk.cc',
        'browser/ui/gtk/infobars/confirm_infobar_gtk.h',
        'browser/ui/gtk/infobars/extension_infobar_gtk.cc',
        'browser/ui/gtk/infobars/extension_infobar_gtk.h',
        'browser/ui/gtk/infobars/infobar_container_gtk.cc',
        'browser/ui/gtk/infobars/infobar_container_gtk.h',
        'browser/ui/gtk/infobars/infobar_gtk.cc',
        'browser/ui/gtk/infobars/infobar_gtk.h',
        'browser/ui/gtk/infobars/link_infobar_gtk.cc',
        'browser/ui/gtk/infobars/link_infobar_gtk.h',
        'browser/ui/gtk/infobars/media_stream_infobar_gtk.cc',
        'browser/ui/gtk/infobars/media_stream_infobar_gtk.h',
        'browser/ui/gtk/infobars/translate_infobar_base_gtk.cc',
        'browser/ui/gtk/infobars/translate_infobar_base_gtk.h',
        'browser/ui/gtk/infobars/translate_message_infobar_gtk.cc',
        'browser/ui/gtk/infobars/translate_message_infobar_gtk.h',
        'browser/ui/gtk/instant_preview_controller_gtk.cc',
        'browser/ui/gtk/instant_preview_controller_gtk.h',
        'browser/ui/gtk/javascript_app_modal_dialog_gtk.cc',
        'browser/ui/gtk/javascript_app_modal_dialog_gtk.h',
        'browser/ui/gtk/location_bar_view_gtk.cc',
        'browser/ui/gtk/location_bar_view_gtk.h',
        'browser/ui/gtk/login_prompt_gtk.cc',
        'browser/ui/gtk/menu_bar_helper.cc',
        'browser/ui/gtk/menu_bar_helper.h',
        'browser/ui/gtk/menu_gtk.cc',
        'browser/ui/gtk/menu_gtk.h',
        'browser/ui/gtk/nine_box.cc',
        'browser/ui/gtk/nine_box.h',
        'browser/ui/gtk/notifications/balloon_collection_gtk.cc',
        'browser/ui/gtk/notifications/balloon_view_gtk.cc',
        'browser/ui/gtk/notifications/balloon_view_gtk.h',
        'browser/ui/gtk/notifications/balloon_view_host_gtk.cc',
        'browser/ui/gtk/notifications/balloon_view_host_gtk.h',
        'browser/ui/gtk/omnibox/omnibox_popup_view_gtk.cc',
        'browser/ui/gtk/omnibox/omnibox_popup_view_gtk.h',
        'browser/ui/gtk/omnibox/omnibox_view_gtk.cc',
        'browser/ui/gtk/omnibox/omnibox_view_gtk.h',
        'browser/ui/gtk/one_click_signin_bubble_gtk.cc',
        'browser/ui/gtk/one_click_signin_bubble_gtk.h',
        'browser/ui/gtk/other_device_menu_gtk.cc',
        'browser/ui/gtk/other_device_menu_gtk.h',
        'browser/ui/gtk/overflow_button.cc',
        'browser/ui/gtk/overflow_button.h',
        'browser/ui/gtk/page_info_bubble_gtk.cc',
        'browser/ui/gtk/panels/display_settings_provider_gtk.cc',
        'browser/ui/gtk/panels/panel_drag_gtk.cc',
        'browser/ui/gtk/panels/panel_drag_gtk.h',
        'browser/ui/gtk/panels/panel_gtk.cc',
        'browser/ui/gtk/panels/panel_gtk.h',
        'browser/ui/gtk/panels/panel_titlebar_gtk.cc',
        'browser/ui/gtk/panels/panel_titlebar_gtk.h',
        'browser/ui/gtk/password_generation_bubble_gtk.cc',
        'browser/ui/gtk/password_generation_bubble_gtk.h',
        'browser/ui/gtk/process_singleton_dialog.cc',
        'browser/ui/gtk/process_singleton_dialog.h',
        'browser/ui/gtk/reload_button_gtk.cc',
        'browser/ui/gtk/reload_button_gtk.h',
        'browser/ui/gtk/rounded_window.cc',
        'browser/ui/gtk/rounded_window.h',
        'browser/ui/gtk/sad_tab_gtk.cc',
        'browser/ui/gtk/sad_tab_gtk.h',
        'browser/ui/gtk/simple_message_box_gtk.cc',
        'browser/ui/gtk/slide_animator_gtk.cc',
        'browser/ui/gtk/slide_animator_gtk.h',
        'browser/ui/gtk/speech_recognition_bubble_gtk.cc',
        'browser/ui/gtk/ssl_client_certificate_selector.cc',
        'browser/ui/gtk/status_bubble_gtk.cc',
        'browser/ui/gtk/status_bubble_gtk.h',
        'browser/ui/gtk/status_icons/status_icon_gtk.cc',
        'browser/ui/gtk/status_icons/status_icon_gtk.h',
        'browser/ui/gtk/status_icons/status_tray_gtk.cc',
        'browser/ui/gtk/status_icons/status_tray_gtk.h',
        'browser/ui/gtk/tab_contents/chrome_web_contents_view_delegate_gtk.cc',
        'browser/ui/gtk/tab_contents/chrome_web_contents_view_delegate_gtk.h',
        'browser/ui/gtk/tab_contents/render_view_context_menu_gtk.cc',
        'browser/ui/gtk/tab_contents/render_view_context_menu_gtk.h',
        'browser/ui/gtk/tab_contents_container_gtk.cc',
        'browser/ui/gtk/tab_contents_container_gtk.h',
        'browser/ui/gtk/tab_modal_confirm_dialog_gtk.cc',
        'browser/ui/gtk/tab_modal_confirm_dialog_gtk.h',
        'browser/ui/gtk/tabs/dock_info_gtk.cc',
        'browser/ui/gtk/tabs/drag_data.cc',
        'browser/ui/gtk/tabs/drag_data.h',
        'browser/ui/gtk/tabs/dragged_tab_controller_gtk.cc',
        'browser/ui/gtk/tabs/dragged_tab_controller_gtk.h',
        'browser/ui/gtk/tabs/dragged_view_gtk.cc',
        'browser/ui/gtk/tabs/dragged_view_gtk.h',
        'browser/ui/gtk/tabs/tab_gtk.cc',
        'browser/ui/gtk/tabs/tab_gtk.h',
        'browser/ui/gtk/tabs/tab_renderer_gtk.cc',
        'browser/ui/gtk/tabs/tab_renderer_gtk.h',
        'browser/ui/gtk/tabs/tab_strip_gtk.cc',
        'browser/ui/gtk/tabs/tab_strip_gtk.h',
        'browser/ui/gtk/tabs/tab_strip_menu_controller.cc',
        'browser/ui/gtk/tabs/tab_strip_menu_controller.h',
        'browser/ui/gtk/task_manager_gtk.cc',
        'browser/ui/gtk/task_manager_gtk.h',
        'browser/ui/gtk/throbber_gtk.cc',
        'browser/ui/gtk/throbber_gtk.h',
        'browser/ui/gtk/titlebar_throb_animation.cc',
        'browser/ui/gtk/titlebar_throb_animation.h',
        'browser/ui/gtk/unity_service.cc',
        'browser/ui/gtk/unity_service.h',
        'browser/ui/gtk/update_recommended_dialog.cc',
        'browser/ui/gtk/update_recommended_dialog.h',
        'browser/ui/gtk/view_id_util.cc',
        'browser/ui/gtk/view_id_util.h',
        'browser/ui/gtk/web_dialog_gtk.cc',
        'browser/ui/gtk/web_dialog_gtk.h',
        'browser/ui/gtk/web_intent_picker_gtk.cc',
        'browser/ui/gtk/web_intent_picker_gtk.h',
        'browser/ui/gtk/website_settings/permission_selector.cc',
        'browser/ui/gtk/website_settings/permission_selector.h',
        'browser/ui/gtk/website_settings/permission_selector_observer.h',
        'browser/ui/gtk/website_settings/website_settings_popup_gtk.cc',
        'browser/ui/gtk/website_settings/website_settings_popup_gtk.h',
        'browser/ui/gtk/zoom_bubble_gtk.cc',
        'browser/ui/gtk/zoom_bubble_gtk.h',
        'browser/ui/host_desktop.cc',
        'browser/ui/host_desktop.h',
        'browser/ui/hung_plugin_tab_helper.cc',
        'browser/ui/hung_plugin_tab_helper.h',
        'browser/ui/intents/web_intent_icon_loader.h',
        'browser/ui/intents/web_intent_icon_loader.cc',
        'browser/ui/intents/native_file_picker_service.cc',
        'browser/ui/intents/web_intent_inline_disposition_delegate.cc',
        'browser/ui/intents/web_intent_inline_disposition_delegate.h',
        'browser/ui/intents/web_intent_picker.cc',
        'browser/ui/intents/web_intent_picker.h',
        'browser/ui/intents/web_intent_picker_controller.cc',
        'browser/ui/intents/web_intent_picker_controller.h',
        'browser/ui/intents/web_intent_picker_delegate.h',
        'browser/ui/intents/web_intent_picker_model.cc',
        'browser/ui/intents/web_intent_picker_model.h',
        'browser/ui/intents/web_intent_picker_model_observer.h',
        'browser/ui/intents/web_intents_model.cc',
        'browser/ui/intents/web_intents_model.h',
        'browser/ui/login/login_model.h',
        'browser/ui/login/login_prompt.cc',
        'browser/ui/login/login_prompt.h',
        'browser/ui/media_stream_infobar_delegate.h',
        'browser/ui/media_stream_infobar_delegate.cc',
        'browser/ui/metro_pin_tab_helper_win.cc',
        'browser/ui/metro_pin_tab_helper_win.h',
        'browser/ui/network_profile_bubble.cc',
        'browser/ui/network_profile_bubble.h',
        'browser/ui/ntp_background_util.cc',
        'browser/ui/ntp_background_util.h',
        'browser/ui/omnibox/location_bar.h',
        'browser/ui/omnibox/location_bar_util.cc',
        'browser/ui/omnibox/location_bar_util.h',
        'browser/ui/omnibox/omnibox_edit_controller.h',
        'browser/ui/omnibox/omnibox_edit_model.cc',
        'browser/ui/omnibox/omnibox_edit_model.h',
        'browser/ui/omnibox/omnibox_popup_model.cc',
        'browser/ui/omnibox/omnibox_popup_model.h',
        'browser/ui/omnibox/omnibox_popup_view.h',
        'browser/ui/omnibox/omnibox_view.cc',
        'browser/ui/omnibox/omnibox_view.h',
        'browser/ui/options/options_util.cc',
        'browser/ui/options/options_util.h',
        'browser/ui/page_info_bubble.h',
        'browser/ui/panels/detached_panel_strip.cc',
        'browser/ui/panels/detached_panel_strip.h',
        'browser/ui/panels/display_settings_provider_win.cc',
        'browser/ui/panels/display_settings_provider_win.h',
        'browser/ui/panels/display_settings_provider.cc',
        'browser/ui/panels/display_settings_provider.h',
        'browser/ui/panels/docked_panel_strip.cc',
        'browser/ui/panels/docked_panel_strip.h',
        'browser/ui/panels/native_panel.h',
        'browser/ui/panels/panel.cc',
        'browser/ui/panels/panel.h',
        'browser/ui/panels/panel_bounds_animation.cc',
        'browser/ui/panels/panel_bounds_animation.h',
        'browser/ui/panels/panel_constants.h',
        'browser/ui/panels/panel_drag_controller.cc',
        'browser/ui/panels/panel_drag_controller.h',
        'browser/ui/panels/panel_host.cc',
        'browser/ui/panels/panel_host.h',
        'browser/ui/panels/panel_resize_controller.cc',
        'browser/ui/panels/panel_resize_controller.h',
        'browser/ui/panels/panel_manager.cc',
        'browser/ui/panels/panel_manager.h',
        'browser/ui/panels/panel_mouse_watcher.cc',
        'browser/ui/panels/panel_mouse_watcher.h',
        'browser/ui/panels/panel_mouse_watcher_observer.h',
        'browser/ui/panels/panel_mouse_watcher_timer.cc',
        'browser/ui/panels/panel_strip.cc',
        'browser/ui/panels/panel_strip.h',
        'browser/ui/panels/taskbar_window_thumbnailer_win.cc',
        'browser/ui/panels/taskbar_window_thumbnailer_win.h',
        'browser/ui/pdf/open_pdf_in_reader_prompt_delegate.h',
        'browser/ui/pdf/pdf_tab_helper.cc',
        'browser/ui/pdf/pdf_tab_helper.h',
        'browser/ui/pdf/pdf_unsupported_feature.cc',
        'browser/ui/pdf/pdf_unsupported_feature.h',
        'browser/ui/prefs/prefs_tab_helper.cc',
        'browser/ui/prefs/prefs_tab_helper.h',
        'browser/ui/profile_error_dialog.cc',
        'browser/ui/profile_error_dialog.h',
        'browser/ui/sad_tab_helper.cc',
        'browser/ui/sad_tab_helper.h',
        'browser/ui/sad_tab_types.h',
        'browser/ui/search/other_device_menu_controller.cc',
        'browser/ui/search/other_device_menu_controller.h',
        'browser/ui/search/search.cc',
        'browser/ui/search/search.h',
        'browser/ui/search/search_delegate.cc',
        'browser/ui/search/search_delegate.h',
        'browser/ui/search/search_model.cc',
        'browser/ui/search/search_model.h',
        'browser/ui/search/search_model_observer.h',
        'browser/ui/search/search_model_observer_bridge.h',
        'browser/ui/search/search_tab_helper.cc',
        'browser/ui/search/search_tab_helper.h',
        'browser/ui/search/search_types.h',
        'browser/ui/search/search_ui.cc',
        'browser/ui/search/search_ui.h',
        'browser/ui/search/toolbar_search_animator.cc',
        'browser/ui/search/toolbar_search_animator.h',
        'browser/ui/search/toolbar_search_animator_observer.h',
        'browser/ui/search_engines/edit_search_engine_controller.cc',
        'browser/ui/search_engines/edit_search_engine_controller.h',
        'browser/ui/search_engines/keyword_editor_controller.cc',
        'browser/ui/search_engines/keyword_editor_controller.h',
        'browser/ui/search_engines/search_engine_tab_helper.cc',
        'browser/ui/search_engines/search_engine_tab_helper.h',
        'browser/ui/search_engines/search_engine_tab_helper_delegate.cc',
        'browser/ui/search_engines/search_engine_tab_helper_delegate.h',
        'browser/ui/search_engines/template_url_fetcher_ui_callbacks.cc',
        'browser/ui/search_engines/template_url_fetcher_ui_callbacks.h',
        'browser/ui/search_engines/template_url_table_model.cc',
        'browser/ui/search_engines/template_url_table_model.h',
        'browser/ui/simple_message_box.h',
        'browser/ui/singleton_tabs.cc',
        'browser/ui/singleton_tabs.h',
        'browser/ui/snapshot_tab_helper.cc',
        'browser/ui/snapshot_tab_helper.h',
        'browser/ui/startup/autolaunch_prompt.cc',
        'browser/ui/startup/autolaunch_prompt_win.cc',
        'browser/ui/startup/autolaunch_prompt.h',
        'browser/ui/startup/bad_flags_prompt.cc',
        'browser/ui/startup/bad_flags_prompt.h',
        'browser/ui/startup/default_browser_prompt.cc',
        'browser/ui/startup/default_browser_prompt.h',
        'browser/ui/startup/default_browser_prompt_win.cc',
        'browser/ui/startup/obsolete_os_prompt.cc',
        'browser/ui/startup/obsolete_os_prompt.h',
        'browser/ui/startup/obsolete_os_prompt_gtk.cc',
        'browser/ui/startup/session_crashed_prompt.cc',
        'browser/ui/startup/session_crashed_prompt.h',
        'browser/ui/startup/startup_browser_creator.cc',
        'browser/ui/startup/startup_browser_creator.h',
        'browser/ui/startup/startup_browser_creator_impl.cc',
        'browser/ui/startup/startup_browser_creator_impl.h',
        'browser/ui/startup/startup_browser_creator_win.cc',
        'browser/ui/startup/startup_browser_creator_win.h',
        'browser/ui/startup/startup_tab.cc',
        'browser/ui/startup/startup_tab.h',
        'browser/ui/startup/startup_types.h',
        'browser/ui/status_bubble.h',
        'browser/ui/sync/browser_synced_window_delegate.h',
        'browser/ui/sync/browser_synced_window_delegate.cc',
        'browser/ui/sync/one_click_signin_helper.cc',
        'browser/ui/sync/one_click_signin_helper.h',
        'browser/ui/sync/one_click_signin_histogram.h',
        'browser/ui/sync/one_click_signin_sync_starter.cc',
        'browser/ui/sync/one_click_signin_sync_starter.h',
        'browser/ui/sync/tab_contents_synced_tab_delegate.cc',
        'browser/ui/sync/tab_contents_synced_tab_delegate.h',
        'browser/ui/tab_contents/chrome_web_contents_view_delegate.h',
        'browser/ui/tab_contents/core_tab_helper.cc',
        'browser/ui/tab_contents/core_tab_helper.h',
        'browser/ui/tab_contents/core_tab_helper_delegate.cc',
        'browser/ui/tab_contents/core_tab_helper_delegate.h',
        'browser/ui/tab_contents/tab_contents.cc',
        'browser/ui/tab_contents/tab_contents.h',
        'browser/ui/tab_contents/tab_contents_iterator.cc',
        'browser/ui/tab_contents/tab_contents_iterator.h',
        'browser/ui/tab_modal_confirm_dialog.h',
        'browser/ui/tab_modal_confirm_dialog_delegate.cc',
        'browser/ui/tab_modal_confirm_dialog_delegate.h',
        'browser/ui/tabs/dock_info.cc',
        'browser/ui/tabs/dock_info.h',
        'browser/ui/tabs/hover_tab_selector.cc',
        'browser/ui/tabs/hover_tab_selector.h',
        'browser/ui/tabs/pinned_tab_codec.cc',
        'browser/ui/tabs/pinned_tab_codec.h',
        'browser/ui/tabs/pinned_tab_service.cc',
        'browser/ui/tabs/pinned_tab_service.h',
        'browser/ui/tabs/pinned_tab_service_factory.cc',
        'browser/ui/tabs/pinned_tab_service_factory.h',
        'browser/ui/tabs/tab_menu_model.cc',
        'browser/ui/tabs/tab_menu_model.h',
        'browser/ui/tabs/tab_resources.cc',
        'browser/ui/tabs/tab_resources.h',
        'browser/ui/tabs/tab_strip_layout_type.h',
        'browser/ui/tabs/tab_strip_layout_type_prefs.cc',
        'browser/ui/tabs/tab_strip_layout_type_prefs.h',
        'browser/ui/tabs/tab_strip_model.cc',
        'browser/ui/tabs/tab_strip_model.h',
        'browser/ui/tabs/tab_strip_model_delegate.h',
        'browser/ui/tabs/tab_strip_model_observer.cc',
        'browser/ui/tabs/tab_strip_model_observer.h',
        'browser/ui/tabs/tab_strip_model_order_controller.cc',
        'browser/ui/tabs/tab_strip_model_order_controller.h',
        'browser/ui/tabs/tab_strip_model_utils.cc',
        'browser/ui/tabs/tab_strip_model_utils.h',
        'browser/ui/tabs/tab_strip_selection_model.cc',
        'browser/ui/tabs/tab_strip_selection_model.h',
        'browser/ui/toolbar/action_box_button_controller.cc',
        'browser/ui/toolbar/action_box_button_controller.h',
        'browser/ui/toolbar/action_box_menu_model.cc',
        'browser/ui/toolbar/action_box_menu_model.h',
        'browser/ui/toolbar/back_forward_menu_model.cc',
        'browser/ui/toolbar/back_forward_menu_model.h',
        'browser/ui/toolbar/bookmark_sub_menu_model.cc',
        'browser/ui/toolbar/bookmark_sub_menu_model.h',
        'browser/ui/toolbar/encoding_menu_controller.cc',
        'browser/ui/toolbar/encoding_menu_controller.h',
        'browser/ui/toolbar/toolbar_model.h',
        'browser/ui/toolbar/toolbar_model_impl.cc',
        'browser/ui/toolbar/toolbar_model_impl.h',
        'browser/ui/toolbar/toolbar_model_delegate.h',
        'browser/ui/toolbar/wrench_menu_model.cc',
        'browser/ui/toolbar/wrench_menu_model.h',
        'browser/ui/top_level_widget.h',
        'browser/ui/uma_browsing_activity_observer.cc',
        'browser/ui/uma_browsing_activity_observer.h',
        'browser/ui/uninstall_browser_prompt.h',
        'browser/ui/unload_controller.cc',
        'browser/ui/unload_controller.h',
        'browser/ui/user_data_dir_dialog.h',
        'browser/ui/view_ids.h',
        'browser/ui/views/about_ipc_dialog.cc',
        'browser/ui/views/about_ipc_dialog.h',
        'browser/ui/views/accelerator_table.cc',
        'browser/ui/views/accelerator_table.h',
        'browser/ui/views/accessibility/accessibility_event_router_views.cc',
        'browser/ui/views/accessibility/accessibility_event_router_views.h',
        'browser/ui/views/accessibility/invert_bubble_view.cc',
        'browser/ui/views/accessibility/invert_bubble_view.h',
        'browser/ui/views/action_box_menu.cc',
        'browser/ui/views/action_box_menu.h',
        'browser/ui/views/app_menu_button_win.cc',
        'browser/ui/views/app_menu_button_win.h',
        'browser/ui/views/app_list/app_list_controller_win.cc',
        'browser/ui/views/ash/balloon_collection_impl_ash.cc',
        'browser/ui/views/ash/balloon_collection_impl_ash.h',
        'browser/ui/views/ash/balloon_view_ash.cc',
        'browser/ui/views/ash/balloon_view_ash.h',
        'browser/ui/views/ash/chrome_browser_main_extra_parts_ash.cc',
        'browser/ui/views/ash/chrome_browser_main_extra_parts_ash.h',
        'browser/ui/views/autofill/autofill_dialog_views.cc',
        'browser/ui/views/autofill/autofill_dialog_views.h',
        'browser/ui/views/autofill/autofill_external_delegate_views.cc',
        'browser/ui/views/autofill/autofill_external_delegate_views.h',
        'browser/ui/views/autofill/autofill_popup_view_views.cc',
        'browser/ui/views/autofill/autofill_popup_view_views.h',
        'browser/ui/views/avatar_menu_bubble_view.cc',
        'browser/ui/views/avatar_menu_bubble_view.h',
        'browser/ui/views/avatar_menu_button.cc',
        'browser/ui/views/avatar_menu_button.h',
        'browser/ui/views/bookmarks/bookmark_bar_instructions_view.cc',
        'browser/ui/views/bookmarks/bookmark_bar_instructions_view.h',
        'browser/ui/views/bookmarks/bookmark_bar_view.cc',
        'browser/ui/views/bookmarks/bookmark_bar_view.h',
        'browser/ui/views/bookmarks/bookmark_bubble_view.cc',
        'browser/ui/views/bookmarks/bookmark_bubble_view.h',
        'browser/ui/views/bookmarks/bookmark_context_menu.cc',
        'browser/ui/views/bookmarks/bookmark_context_menu.h',
        'browser/ui/views/bookmarks/bookmark_context_menu_controller_views.cc',
        'browser/ui/views/bookmarks/bookmark_context_menu_controller_views.h',
        'browser/ui/views/bookmarks/bookmark_context_menu_controller_views_win.cc',
        'browser/ui/views/bookmarks/bookmark_context_menu_controller_views_win.h',
        'browser/ui/views/bookmarks/bookmark_editor_view.cc',
        'browser/ui/views/bookmarks/bookmark_editor_view.h',
        'browser/ui/views/bookmarks/bookmark_menu_controller_views.cc',
        'browser/ui/views/bookmarks/bookmark_menu_controller_views.h',
        'browser/ui/views/bookmarks/bookmark_menu_delegate.cc',
        'browser/ui/views/bookmarks/bookmark_menu_delegate.h',
        'browser/ui/views/browser_action_test_util_views.cc',
        'browser/ui/views/browser_action_view.cc',
        'browser/ui/views/browser_action_view.h',
        'browser/ui/views/browser_actions_container.cc',
        'browser/ui/views/browser_actions_container.h',
        'browser/ui/views/browser_dialogs.h',
        'browser/ui/views/certificate_viewer_win.cc',
        'browser/ui/views/chrome_browser_main_extra_parts_views.cc',
        'browser/ui/views/chrome_browser_main_extra_parts_views.h',
        'browser/ui/views/chrome_to_mobile_bubble_view.cc',
        'browser/ui/views/chrome_to_mobile_bubble_view.h',
        'browser/ui/views/chrome_views_delegate.cc',
        'browser/ui/views/chrome_views_delegate.h',
        'browser/ui/views/chrome_web_dialog_view.cc',
        'browser/ui/views/collected_cookies_views.cc',
        'browser/ui/views/collected_cookies_views.h',
        'browser/ui/views/color_chooser_aura.cc',
        'browser/ui/views/color_chooser_dialog.cc',
        'browser/ui/views/color_chooser_dialog.h',
        'browser/ui/views/color_chooser_win.cc',
        'browser/ui/views/confirm_bubble_views.cc',
        'browser/ui/views/confirm_bubble_views.h',
        'browser/ui/views/constrained_web_dialog_delegate_views.cc',
        'browser/ui/views/constrained_window_frame_simple.cc',
        'browser/ui/views/constrained_window_frame_simple.h',
        'browser/ui/views/constrained_window_views.cc',
        'browser/ui/views/constrained_window_views.h',
        'browser/ui/views/content_setting_bubble_contents.cc',
        'browser/ui/views/content_setting_bubble_contents.h',
        'browser/ui/views/cookie_info_view.cc',
        'browser/ui/views/cookie_info_view.h',
        'browser/ui/views/create_application_shortcut_view.cc',
        'browser/ui/views/create_application_shortcut_view.h',
        'browser/ui/views/crypto_module_password_dialog_view.cc',
        'browser/ui/views/crypto_module_password_dialog_view.h',
        'browser/ui/views/critical_notification_bubble_view.cc',
        'browser/ui/views/critical_notification_bubble_view.h',
        'browser/ui/views/detachable_toolbar_view.cc',
        'browser/ui/views/detachable_toolbar_view.h',
        'browser/ui/views/download/download_in_progress_dialog_view.cc',
        'browser/ui/views/download/download_in_progress_dialog_view.h',
        'browser/ui/views/download/download_item_view.cc',
        'browser/ui/views/download/download_item_view.h',
        'browser/ui/views/download/download_shelf_context_menu_view.cc',
        'browser/ui/views/download/download_shelf_context_menu_view.h',
        'browser/ui/views/download/download_shelf_view.cc',
        'browser/ui/views/download/download_shelf_view.h',
        'browser/ui/views/download/download_started_animation_views.cc',
        'browser/ui/views/dropdown_bar_host.cc',
        'browser/ui/views/dropdown_bar_host.h',
        'browser/ui/views/dropdown_bar_host_aura.cc',
        'browser/ui/views/dropdown_bar_host_delegate.h',
        'browser/ui/views/dropdown_bar_host_win.cc',
        'browser/ui/views/dropdown_bar_view.cc',
        'browser/ui/views/dropdown_bar_view.h',
        'browser/ui/views/edit_search_engine_dialog.cc',
        'browser/ui/views/edit_search_engine_dialog.h',
        'browser/ui/views/event_utils.cc',
        'browser/ui/views/event_utils.h',
        'browser/ui/views/extensions/browser_action_drag_data.cc',
        'browser/ui/views/extensions/browser_action_drag_data.h',
        'browser/ui/views/extensions/browser_action_overflow_menu_controller.cc',
        'browser/ui/views/extensions/browser_action_overflow_menu_controller.h',
        'browser/ui/views/extensions/bundle_installed_bubble.cc',
        'browser/ui/views/extensions/disabled_extensions_view.cc',
        'browser/ui/views/extensions/disabled_extensions_view.h',
        'browser/ui/views/extensions/extension_dialog.cc',
        'browser/ui/views/extensions/extension_dialog.h',
        'browser/ui/views/extensions/extension_dialog_observer.cc',
        'browser/ui/views/extensions/extension_dialog_observer.h',
        'browser/ui/views/extensions/extension_install_dialog_view.cc',
        'browser/ui/views/extensions/extension_installed_bubble.cc',
        'browser/ui/views/extensions/extension_installed_bubble.h',
        'browser/ui/views/extensions/extension_keybinding_registry_views.cc',
        'browser/ui/views/extensions/extension_keybinding_registry_views.h',
        'browser/ui/views/extensions/extension_popup.cc',
        'browser/ui/views/extensions/extension_popup.h',
        'browser/ui/views/extensions/extension_uninstall_dialog_view.cc',
        'browser/ui/views/extensions/extension_view_views.cc',
        'browser/ui/views/extensions/extension_view_views.h',
        'browser/ui/views/extensions/media_galleries_dialog_views.cc',
        'browser/ui/views/extensions/media_galleries_dialog_views.h',
        'browser/ui/views/extensions/shell_window_views.cc',
        'browser/ui/views/extensions/shell_window_views.h',
        'browser/ui/views/external_protocol_dialog.cc',
        'browser/ui/views/external_protocol_dialog.h',
        'browser/ui/views/external_tab_container_win.cc',
        'browser/ui/views/external_tab_container_win.h',
        'browser/ui/views/find_bar_host.cc',
        'browser/ui/views/find_bar_host.h',
        'browser/ui/views/find_bar_host_aura.cc',
        'browser/ui/views/find_bar_host_win.cc',
        'browser/ui/views/find_bar_view.cc',
        'browser/ui/views/find_bar_view.h',
        'browser/ui/views/first_run_bubble.cc',
        'browser/ui/views/first_run_bubble.h',
        'browser/ui/views/frame/app_non_client_frame_view_ash.cc',
        'browser/ui/views/frame/app_non_client_frame_view_ash.h',
        'browser/ui/views/frame/app_panel_browser_frame_view.cc',
        'browser/ui/views/frame/app_panel_browser_frame_view.h',
        'browser/ui/views/frame/browser_frame.cc',
        'browser/ui/views/frame/browser_frame.h',
        'browser/ui/views/frame/browser_frame_aura.cc',
        'browser/ui/views/frame/browser_frame_aura.h',
        'browser/ui/views/frame/browser_frame_win.cc',
        'browser/ui/views/frame/browser_frame_win.h',
        'browser/ui/views/frame/browser_non_client_frame_view.cc',
        'browser/ui/views/frame/browser_non_client_frame_view.h',
        'browser/ui/views/frame/browser_non_client_frame_view_ash.h',
        'browser/ui/views/frame/browser_non_client_frame_view_ash.cc',
        'browser/ui/views/frame/browser_non_client_frame_view_factory_aura.cc',
        'browser/ui/views/frame/browser_non_client_frame_view_factory_win.cc',
        'browser/ui/views/frame/browser_non_client_frame_view_factory_x11.cc',
        'browser/ui/views/frame/browser_root_view.cc',
        'browser/ui/views/frame/browser_root_view.h',
        'browser/ui/views/frame/browser_view.cc',
        'browser/ui/views/frame/browser_view.h',
        'browser/ui/views/frame/browser_view_layout.cc',
        'browser/ui/views/frame/browser_view_layout.h',
        'browser/ui/views/frame/contents_container.cc',
        'browser/ui/views/frame/contents_container.h',
        'browser/ui/views/frame/desktop_browser_frame_aura.cc',
        'browser/ui/views/frame/desktop_browser_frame_aura.h',
        'browser/ui/views/frame/browser_desktop_root_window_host.h',
        'browser/ui/views/frame/browser_desktop_root_window_host_linux.cc',
        'browser/ui/views/frame/browser_desktop_root_window_host_linux.h',
        'browser/ui/views/frame/browser_desktop_root_window_host_win.cc',
        'browser/ui/views/frame/browser_desktop_root_window_host_win.h',
        'browser/ui/views/frame/glass_browser_frame_view.cc',
        'browser/ui/views/frame/glass_browser_frame_view.h',
        'browser/ui/views/frame/instant_preview_controller_views.cc',
        'browser/ui/views/frame/instant_preview_controller_views.h',
        'browser/ui/views/frame/minimize_button_metrics_win.cc',
        'browser/ui/views/frame/minimize_button_metrics_win.h',
        'browser/ui/views/frame/native_browser_frame.h',
        'browser/ui/views/frame/opaque_browser_frame_view.cc',
        'browser/ui/views/frame/opaque_browser_frame_view.h',
        'browser/ui/views/frame/popup_non_client_frame_view.cc',
        'browser/ui/views/frame/popup_non_client_frame_view.h',
        'browser/ui/views/frame/system_menu_model.cc',
        'browser/ui/views/frame/system_menu_model.h',
        'browser/ui/views/frame/system_menu_model_delegate.cc',
        'browser/ui/views/frame/system_menu_model_delegate.h',
        'browser/ui/views/fullscreen_exit_bubble_views.cc',
        'browser/ui/views/fullscreen_exit_bubble_views.h',
        'browser/ui/views/global_error_bubble_view.cc',
        'browser/ui/views/global_error_bubble_view.h',
        'browser/ui/views/hung_renderer_view.cc',
        'browser/ui/views/hung_renderer_view.h',
        'browser/ui/views/hung_renderer_view_win.cc',
        'browser/ui/views/hung_renderer_view_win.h',
        'browser/ui/views/importer/import_lock_dialog_view.cc',
        'browser/ui/views/importer/import_lock_dialog_view.h',
        'browser/ui/views/importer/import_progress_dialog_view.cc',
        'browser/ui/views/importer/import_progress_dialog_view.h',
        'browser/ui/views/infobars/after_translate_infobar.cc',
        'browser/ui/views/infobars/after_translate_infobar.h',
        'browser/ui/views/infobars/before_translate_infobar.cc',
        'browser/ui/views/infobars/before_translate_infobar.h',
        'browser/ui/views/infobars/confirm_infobar.cc',
        'browser/ui/views/infobars/confirm_infobar.h',
        'browser/ui/views/infobars/extension_infobar.cc',
        'browser/ui/views/infobars/extension_infobar.h',
        'browser/ui/views/infobars/infobar_background.cc',
        'browser/ui/views/infobars/infobar_background.h',
        'browser/ui/views/infobars/infobar_button_border.cc',
        'browser/ui/views/infobars/infobar_button_border.h',
        'browser/ui/views/infobars/infobar_container_view.cc',
        'browser/ui/views/infobars/infobar_container_view.h',
        'browser/ui/views/infobars/infobar_view.cc',
        'browser/ui/views/infobars/infobar_view.h',
        'browser/ui/views/infobars/link_infobar.cc',
        'browser/ui/views/infobars/link_infobar.h',
        'browser/ui/views/infobars/media_stream_infobar.cc',
        'browser/ui/views/infobars/media_stream_infobar.h',
        'browser/ui/views/infobars/one_click_signin_infobar.cc',
        'browser/ui/views/infobars/one_click_signin_infobar.h',
        'browser/ui/views/infobars/translate_infobar_base.cc',
        'browser/ui/views/infobars/translate_infobar_base.h',
        'browser/ui/views/infobars/translate_language_menu_model.cc',
        'browser/ui/views/infobars/translate_language_menu_model.h',
        'browser/ui/views/infobars/translate_message_infobar.cc',
        'browser/ui/views/infobars/translate_message_infobar.h',
        'browser/ui/views/javascript_app_modal_dialog_views.cc',
        'browser/ui/views/javascript_app_modal_dialog_views.h',
        'browser/ui/views/location_bar/action_box_button_view.cc',
        'browser/ui/views/location_bar/action_box_button_view.h',
        'browser/ui/views/location_bar/content_setting_image_view.cc',
        'browser/ui/views/location_bar/content_setting_image_view.h',
        'browser/ui/views/location_bar/ev_bubble_view.cc',
        'browser/ui/views/location_bar/ev_bubble_view.h',
        'browser/ui/views/location_bar/icon_label_bubble_view.cc',
        'browser/ui/views/location_bar/icon_label_bubble_view.h',
        'browser/ui/views/location_bar/keyword_hint_view.cc',
        'browser/ui/views/location_bar/keyword_hint_view.h',
        'browser/ui/views/location_bar/location_bar_container.cc',
        'browser/ui/views/location_bar/location_bar_container.h',
        'browser/ui/views/location_bar/location_bar_container_aura.cc',
        'browser/ui/views/location_bar/location_bar_container_win.cc',
        'browser/ui/views/location_bar/location_bar_decoration_view.cc',
        'browser/ui/views/location_bar/location_bar_decoration_view.h',
        'browser/ui/views/location_bar/location_bar_view.cc',
        'browser/ui/views/location_bar/location_bar_view.h',
        'browser/ui/views/location_bar/location_icon_view.cc',
        'browser/ui/views/location_bar/location_icon_view.h',
        'browser/ui/views/location_bar/open_pdf_in_reader_view.cc',
        'browser/ui/views/location_bar/open_pdf_in_reader_view.h',
        'browser/ui/views/location_bar/page_action_image_view.cc',
        'browser/ui/views/location_bar/page_action_image_view.h',
        'browser/ui/views/location_bar/page_action_with_badge_view.cc',
        'browser/ui/views/location_bar/page_action_with_badge_view.h',
        'browser/ui/views/location_bar/page_info_helper.cc',
        'browser/ui/views/location_bar/page_info_helper.h',
        'browser/ui/views/location_bar/selected_keyword_view.cc',
        'browser/ui/views/location_bar/selected_keyword_view.h',
        'browser/ui/views/location_bar/star_view.cc',
        'browser/ui/views/location_bar/star_view.h',
        'browser/ui/views/location_bar/touchable_location_bar_view.cc',
        'browser/ui/views/location_bar/touchable_location_bar_view.h',
        'browser/ui/views/location_bar/zoom_bubble_view.cc',
        'browser/ui/views/location_bar/zoom_bubble_view.h',
        'browser/ui/views/location_bar/zoom_view.cc',
        'browser/ui/views/location_bar/zoom_view.h',
        'browser/ui/views/location_bar/web_intents_button_view.cc',
        'browser/ui/views/location_bar/web_intents_button_view.h',
        'browser/ui/views/login_prompt_views.cc',
        'browser/ui/views/login_view.cc',
        'browser/ui/views/login_view.h',
        'browser/ui/views/native_constrained_window_aura.cc',
        'browser/ui/views/native_constrained_window_win.cc',
        'browser/ui/views/notifications/balloon_collection_views.cc',
        'browser/ui/views/notifications/balloon_view_host.cc',
        'browser/ui/views/notifications/balloon_view_host.h',
        'browser/ui/views/notifications/balloon_view_views.cc',
        'browser/ui/views/notifications/balloon_view_views.h',
        'browser/ui/views/omnibox/omnibox_popup_contents_view.cc',
        'browser/ui/views/omnibox/omnibox_popup_contents_view.h',
        'browser/ui/views/omnibox/omnibox_popup_non_view.cc',
        'browser/ui/views/omnibox/omnibox_popup_non_view.h',
        'browser/ui/views/omnibox/omnibox_result_view.cc',
        'browser/ui/views/omnibox/omnibox_result_view.h',
        'browser/ui/views/omnibox/omnibox_result_view_model.h',
        'browser/ui/views/omnibox/omnibox_views.cc',
        'browser/ui/views/omnibox/omnibox_views.h',
        'browser/ui/views/omnibox/omnibox_view_views.cc',
        'browser/ui/views/omnibox/omnibox_view_views.h',
        'browser/ui/views/omnibox/omnibox_view_win.cc',
        'browser/ui/views/omnibox/omnibox_view_win.h',
        'browser/ui/views/omnibox/touch_omnibox_popup_contents_view.cc',
        'browser/ui/views/omnibox/touch_omnibox_popup_contents_view.h',
        'browser/ui/views/open_pdf_in_reader_bubble_view.cc',
        'browser/ui/views/open_pdf_in_reader_bubble_view.h',
        'browser/ui/views/other_device_menu_views.cc',
        'browser/ui/views/other_device_menu_views.h',
        'browser/ui/views/page_info_bubble_view.cc',
        'browser/ui/views/page_info_bubble_view.h',
        'browser/ui/views/panels/panel_frame_view.cc',
        'browser/ui/views/panels/panel_frame_view.h',
        'browser/ui/views/panels/panel_view.cc',
        'browser/ui/views/panels/panel_view.h',
        'browser/ui/views/password_generation_bubble_view.cc',
        'browser/ui/views/password_generation_bubble_view.h',
        'browser/ui/views/reload_button.cc',
        'browser/ui/views/reload_button.h',
        'browser/ui/views/sad_tab_view.cc',
        'browser/ui/views/sad_tab_view.h',
        'browser/ui/views/search/search_ntp_container_view.cc',
        'browser/ui/views/search/search_ntp_container_view.h',
        'browser/ui/views/search/search_view_controller.cc',
        'browser/ui/views/search/search_view_controller.h',
        'browser/ui/views/select_file_dialog_extension.cc',
        'browser/ui/views/select_file_dialog_extension.h',
        'browser/ui/views/select_file_dialog_extension_factory.cc',
        'browser/ui/views/select_file_dialog_extension_factory.h',
        'browser/ui/views/simple_message_box_views.cc',
        'browser/ui/views/simple_message_box_win.cc',
        'browser/ui/views/speech_recognition_bubble_views.cc',
        'browser/ui/views/ssl_client_certificate_selector.cc',
        'browser/ui/views/ssl_client_certificate_selector.h',
        'browser/ui/views/status_bubble_views.cc',
        'browser/ui/views/status_bubble_views.h',
        'browser/ui/views/status_icons/status_icon_win.cc',
        'browser/ui/views/status_icons/status_icon_win.h',
        'browser/ui/views/status_icons/status_tray_linux.cc',
        'browser/ui/views/status_icons/status_tray_win.cc',
        'browser/ui/views/status_icons/status_tray_win.h',
        'browser/ui/views/stubs_aura.cc',
        'browser/ui/views/sync/one_click_signin_bubble_view.cc',
        'browser/ui/views/sync/one_click_signin_bubble_view.h',
        'browser/ui/views/tab_contents/chrome_web_contents_view_delegate_views.cc',
        'browser/ui/views/tab_contents/chrome_web_contents_view_delegate_views.h',
        'browser/ui/views/tab_contents/render_view_context_menu_views.cc',
        'browser/ui/views/tab_contents/render_view_context_menu_views.h',
        'browser/ui/views/tab_contents/render_view_context_menu_win.cc',
        'browser/ui/views/tab_contents/render_view_context_menu_win.h',
        'browser/ui/views/tab_icon_view.cc',
        'browser/ui/views/tab_icon_view.h',
        'browser/ui/views/tab_icon_view_model.h',
        'browser/ui/views/tab_modal_confirm_dialog_views.cc',
        'browser/ui/views/tab_modal_confirm_dialog_views.h',
        'browser/ui/views/tabs/base_tab.cc',
        'browser/ui/views/tabs/base_tab.h',
        'browser/ui/views/tabs/browser_tab_strip_controller.cc',
        'browser/ui/views/tabs/browser_tab_strip_controller.h',
        'browser/ui/views/tabs/dock_info_views.cc',
        'browser/ui/views/tabs/dock_info_win.cc',
        'browser/ui/views/tabs/dragged_tab_view.cc',
        'browser/ui/views/tabs/dragged_tab_view.h',
        'browser/ui/views/tabs/native_view_photobooth.h',
        'browser/ui/views/tabs/native_view_photobooth_win.cc',
        'browser/ui/views/tabs/native_view_photobooth_win.h',
        'browser/ui/views/tabs/tab.cc',
        'browser/ui/views/tabs/tab.h',
        'browser/ui/views/tabs/tab_controller.h',
        'browser/ui/views/tabs/tab_drag_controller.cc',
        'browser/ui/views/tabs/tab_drag_controller.h',
        'browser/ui/views/tabs/tab_renderer_data.cc',
        'browser/ui/views/tabs/tab_renderer_data.h',
        'browser/ui/views/tabs/tab_strip.cc',
        'browser/ui/views/tabs/tab_strip.h',
        'browser/ui/views/tabs/tab_strip_controller.h',
        'browser/ui/views/tabs/tab_strip_types.h',
        'browser/ui/views/tabs/touch_tab_strip_layout.cc',
        'browser/ui/views/tabs/touch_tab_strip_layout.h',
        'browser/ui/views/task_manager_view.cc',
        'browser/ui/views/theme_background.cc',
        'browser/ui/views/theme_background.h',
        'browser/ui/views/theme_helpers.cc',
        'browser/ui/views/theme_helpers.h',
        'browser/ui/views/toolbar_view.cc',
        'browser/ui/views/toolbar_view.h',
        'browser/ui/views/top_level_widget_views.cc',
        'browser/ui/views/unhandled_keyboard_event_handler.cc',
        'browser/ui/views/unhandled_keyboard_event_handler.h',
        'browser/ui/views/unhandled_keyboard_event_handler_aurax11.cc',
        'browser/ui/views/unhandled_keyboard_event_handler_win.cc',
        'browser/ui/views/uninstall_view.cc',
        'browser/ui/views/uninstall_view.h',
        'browser/ui/views/update_recommended_message_box.cc',
        'browser/ui/views/update_recommended_message_box.h',
        'browser/ui/views/user_data_dir_dialog_view.cc',
        'browser/ui/views/user_data_dir_dialog_view.h',
        'browser/ui/views/web_intent_picker_views.cc',
        'browser/ui/views/website_settings/permission_selector_view.cc',
        'browser/ui/views/website_settings/permission_selector_view.h',
        'browser/ui/views/website_settings/permission_selector_view_observer.h',
        'browser/ui/views/website_settings/website_settings_popup_view.cc',
        'browser/ui/views/website_settings/website_settings_popup_view.h',
        'browser/ui/views/wrench_menu.cc',
        'browser/ui/views/wrench_menu.h',
        'browser/ui/web_applications/web_app_ui.cc',
        'browser/ui/web_applications/web_app_ui.h',
        'browser/ui/website_settings/permission_menu_model.cc',
        'browser/ui/website_settings/permission_menu_model.h',
        'browser/ui/website_settings/website_settings.cc',
        'browser/ui/website_settings/website_settings.h',
        'browser/ui/website_settings/website_settings_infobar_delegate.cc',
        'browser/ui/website_settings/website_settings_infobar_delegate.h',
        'browser/ui/website_settings/website_settings_ui.cc',
        'browser/ui/website_settings/website_settings_ui.h',
        'browser/ui/website_settings/website_settings_utils.cc',
        'browser/ui/website_settings/website_settings_utils.h',
        'browser/ui/webui/about_ui.cc',
        'browser/ui/webui/about_ui.h',
        'browser/ui/webui/bookmarks_ui.cc',
        'browser/ui/webui/bookmarks_ui.h',
        'browser/ui/webui/certificate_viewer_webui.cc',
        'browser/ui/webui/certificate_viewer_webui.h',
        'browser/ui/webui/certificate_viewer_ui.cc',
        'browser/ui/webui/certificate_viewer_ui.h',
        'browser/ui/webui/chrome_url_data_manager.cc',
        'browser/ui/webui/chrome_url_data_manager.h',
        'browser/ui/webui/chrome_url_data_manager_backend.cc',
        'browser/ui/webui/chrome_url_data_manager_backend.h',
        'browser/ui/webui/chrome_url_data_manager_factory.cc',
        'browser/ui/webui/chrome_url_data_manager_factory.h',
        'browser/ui/webui/chrome_web_contents_handler.cc',
        'browser/ui/webui/chrome_web_contents_handler.h',
        'browser/ui/webui/chrome_web_ui_controller_factory.cc',
        'browser/ui/webui/chrome_web_ui_controller_factory.h',
        'browser/ui/webui/chrome_web_ui_data_source.cc',
        'browser/ui/webui/chrome_web_ui_data_source.h',
        'browser/ui/webui/chromeos/choose_mobile_network_ui.cc',
        'browser/ui/webui/chromeos/choose_mobile_network_ui.h',
        'browser/ui/webui/chromeos/cryptohome_ui.cc',
        'browser/ui/webui/chromeos/cryptohome_ui.h',
        'browser/ui/webui/chromeos/cryptohome_web_ui_handler.cc',
        'browser/ui/webui/chromeos/cryptohome_web_ui_handler.h',
        'browser/ui/webui/chromeos/diagnostics/diagnostics_ui.cc',
        'browser/ui/webui/chromeos/diagnostics/diagnostics_ui.h',
        'browser/ui/webui/chromeos/drive_internals_ui.cc',
        'browser/ui/webui/chromeos/drive_internals_ui.h',
        'browser/ui/webui/chromeos/imageburner/imageburner_ui.cc',
        'browser/ui/webui/chromeos/imageburner/imageburner_ui.h',
        'browser/ui/webui/chromeos/keyboard_overlay_ui.cc',
        'browser/ui/webui/chromeos/keyboard_overlay_ui.h',
        'browser/ui/webui/chromeos/login/base_screen_handler.cc',
        'browser/ui/webui/chromeos/login/base_screen_handler.h',
        'browser/ui/webui/chromeos/login/core_oobe_handler.cc',
        'browser/ui/webui/chromeos/login/core_oobe_handler.h',
        'browser/ui/webui/chromeos/login/enterprise_oauth_enrollment_screen_handler.cc',
        'browser/ui/webui/chromeos/login/enterprise_oauth_enrollment_screen_handler.h',
        'browser/ui/webui/chromeos/login/error_screen_handler.cc',
        'browser/ui/webui/chromeos/login/error_screen_handler.h',
        'browser/ui/webui/chromeos/login/eula_screen_handler.cc',
        'browser/ui/webui/chromeos/login/eula_screen_handler.h',
        'browser/ui/webui/chromeos/login/network_dropdown.cc',
        'browser/ui/webui/chromeos/login/network_dropdown.h',
        'browser/ui/webui/chromeos/login/network_dropdown_handler.cc',
        'browser/ui/webui/chromeos/login/network_dropdown_handler.h',
        'browser/ui/webui/chromeos/login/network_screen_handler.cc',
        'browser/ui/webui/chromeos/login/network_screen_handler.h',
	'browser/ui/webui/chromeos/login/network_state_informer.cc',
        'browser/ui/webui/chromeos/login/network_state_informer.h',
        'browser/ui/webui/chromeos/login/oobe_ui.cc',
        'browser/ui/webui/chromeos/login/oobe_ui.h',
        'browser/ui/webui/chromeos/login/reset_screen_handler.cc',
        'browser/ui/webui/chromeos/login/reset_screen_handler.h',
        'browser/ui/webui/chromeos/login/signin_screen_handler.cc',
        'browser/ui/webui/chromeos/login/signin_screen_handler.h',
        'browser/ui/webui/chromeos/login/update_screen_handler.cc',
        'browser/ui/webui/chromeos/login/update_screen_handler.h',
        'browser/ui/webui/chromeos/login/user_image_screen_handler.cc',
        'browser/ui/webui/chromeos/login/user_image_screen_handler.h',
        'browser/ui/webui/chromeos/mobile_setup_dialog.cc',
        'browser/ui/webui/chromeos/mobile_setup_dialog.h',
        'browser/ui/webui/chromeos/mobile_setup_ui.cc',
        'browser/ui/webui/chromeos/mobile_setup_ui.h',
        'browser/ui/webui/chromeos/proxy_settings_ui.cc',
        'browser/ui/webui/chromeos/proxy_settings_ui.h',
        'browser/ui/webui/chromeos/register_page_ui.cc',
        'browser/ui/webui/chromeos/register_page_ui.h',
        'browser/ui/webui/chromeos/sim_unlock_ui.cc',
        'browser/ui/webui/chromeos/sim_unlock_ui.h',
        'browser/ui/webui/chromeos/system_info_ui.cc',
        'browser/ui/webui/chromeos/system_info_ui.h',
        'browser/ui/webui/chromeos/ui_account_tweaks.cc',
        'browser/ui/webui/chromeos/ui_account_tweaks.h',
        'browser/ui/webui/constrained_web_dialog_delegate_base.cc',
        'browser/ui/webui/constrained_web_dialog_delegate_base.h',
        'browser/ui/webui/cookies_tree_model_util.cc',
        'browser/ui/webui/cookies_tree_model_util.h',
        'browser/ui/webui/crashes_ui.cc',
        'browser/ui/webui/crashes_ui.h',
        'browser/ui/webui/devtools_ui.cc',
        'browser/ui/webui/devtools_ui.h',
        'browser/ui/webui/downloads_dom_handler.cc',
        'browser/ui/webui/downloads_dom_handler.h',
        'browser/ui/webui/downloads_ui.cc',
        'browser/ui/webui/downloads_ui.h',
        'browser/ui/webui/extensions/command_handler.cc',
        'browser/ui/webui/extensions/command_handler.h',
        'browser/ui/webui/extensions/extension_activity_ui.cc',
        'browser/ui/webui/extensions/extension_activity_ui.h',
        'browser/ui/webui/extensions/extension_icon_source.cc',
        'browser/ui/webui/extensions/extension_icon_source.h',
        'browser/ui/webui/extensions/extension_info_ui.cc',
        'browser/ui/webui/extensions/extension_info_ui.h',
        'browser/ui/webui/extensions/extension_settings_handler.cc',
        'browser/ui/webui/extensions/extension_settings_handler.h',
        'browser/ui/webui/extensions/extensions_ui.cc',
        'browser/ui/webui/extensions/extensions_ui.h',
        'browser/ui/webui/extensions/install_extension_handler.cc',
        'browser/ui/webui/extensions/install_extension_handler.h',
        'browser/ui/webui/extensions/pack_extension_handler.cc',
        'browser/ui/webui/extensions/pack_extension_handler.h',
        'browser/ui/webui/favicon_source.cc',
        'browser/ui/webui/favicon_source.h',
        'browser/ui/webui/feedback_ui.cc',
        'browser/ui/webui/feedback_ui.h',
        'browser/ui/webui/fileicon_source.cc',
        'browser/ui/webui/fileicon_source.h',
        'browser/ui/webui/flags_ui.cc',
        'browser/ui/webui/flags_ui.h',
        'browser/ui/webui/flash_ui.cc',
        'browser/ui/webui/flash_ui.h',
        'browser/ui/webui/generic_handler.cc',
        'browser/ui/webui/generic_handler.h',
        'browser/ui/webui/gesture_config_ui.cc',
        'browser/ui/webui/gesture_config_ui.h',
        'browser/ui/webui/gpu_internals_ui.cc',
        'browser/ui/webui/gpu_internals_ui.h',
        'browser/ui/webui/help/help_handler.cc',
        'browser/ui/webui/help/help_handler.h',
        'browser/ui/webui/help/help_ui.cc',
        'browser/ui/webui/help/help_ui.h',
        'browser/ui/webui/help/version_updater.h',
        'browser/ui/webui/help/version_updater_basic.cc',
        'browser/ui/webui/help/version_updater_basic.h',
        'browser/ui/webui/help/version_updater_chromeos.cc',
        'browser/ui/webui/help/version_updater_chromeos.h',
        'browser/ui/webui/help/version_updater_mac.mm',
        'browser/ui/webui/help/version_updater_mac.h',
        'browser/ui/webui/help/version_updater_win.cc',
        'browser/ui/webui/history_ui.cc',
        'browser/ui/webui/history_ui.h',
        'browser/ui/webui/inspect_ui.cc',
        'browser/ui/webui/inspect_ui.h',
        'browser/ui/webui/instant_ui.cc',
        'browser/ui/webui/instant_ui.h',
        'browser/ui/webui/media/media_internals_handler.cc',
        'browser/ui/webui/media/media_internals_handler.h',
        'browser/ui/webui/media/media_internals_proxy.cc',
        'browser/ui/webui/media/media_internals_proxy.h',
        'browser/ui/webui/media/media_internals_ui.cc',
        'browser/ui/webui/media/media_internals_ui.h',
        'browser/ui/webui/metrics_handler.cc',
        'browser/ui/webui/metrics_handler.h',
        'browser/ui/webui/nacl_ui.cc',
        'browser/ui/webui/nacl_ui.h',
        'browser/ui/webui/set_as_default_browser_ui.cc',
        'browser/ui/webui/set_as_default_browser_ui.h',
        'browser/ui/webui/net_internals/net_internals_ui.cc',
        'browser/ui/webui/net_internals/net_internals_ui.h',
        'browser/ui/webui/ntp/app_launcher_handler.cc',
        'browser/ui/webui/ntp/app_launcher_handler.h',
        'browser/ui/webui/ntp/favicon_webui_handler.cc',
        'browser/ui/webui/ntp/favicon_webui_handler.h',
        'browser/ui/webui/ntp/foreign_session_handler.cc',
        'browser/ui/webui/ntp/foreign_session_handler.h',
        'browser/ui/webui/ntp/most_visited_handler.cc',
        'browser/ui/webui/ntp/most_visited_handler.h',
        'browser/ui/webui/ntp/new_tab_page_handler.cc',
        'browser/ui/webui/ntp/new_tab_page_handler.h',
        'browser/ui/webui/ntp/new_tab_page_sync_handler.cc',
        'browser/ui/webui/ntp/new_tab_page_sync_handler.h',
        'browser/ui/webui/ntp/new_tab_ui.cc',
        'browser/ui/webui/ntp/new_tab_ui.h',
        'browser/ui/webui/ntp/ntp_login_handler.cc',
        'browser/ui/webui/ntp/ntp_login_handler.h',
        'browser/ui/webui/ntp/ntp_resource_cache_android.cc',
        'browser/ui/webui/ntp/ntp_resource_cache.cc',
        'browser/ui/webui/ntp/ntp_resource_cache.h',
        'browser/ui/webui/ntp/ntp_resource_cache_factory.cc',
        'browser/ui/webui/ntp/ntp_resource_cache_factory.h',
        'browser/ui/webui/ntp/ntp_stats.h',
        'browser/ui/webui/ntp/recently_closed_tabs_handler.cc',
        'browser/ui/webui/ntp/recently_closed_tabs_handler.h',
        'browser/ui/webui/ntp/suggestions_combiner.cc',
        'browser/ui/webui/ntp/suggestions_combiner.h',
        'browser/ui/webui/ntp/suggestions_page_handler.cc',
        'browser/ui/webui/ntp/suggestions_page_handler.h',
        'browser/ui/webui/ntp/suggestions_source.h',
        'browser/ui/webui/ntp/suggestions_source_discovery.cc',
        'browser/ui/webui/ntp/suggestions_source_discovery.h',
        'browser/ui/webui/ntp/suggestions_source_top_sites.cc',
        'browser/ui/webui/ntp/suggestions_source_top_sites.h',
        'browser/ui/webui/ntp/thumbnail_source.cc',
        'browser/ui/webui/ntp/thumbnail_source.h',
        'browser/ui/webui/omnibox/omnibox_ui.cc',
        'browser/ui/webui/omnibox/omnibox_ui.h',
        'browser/ui/webui/omnibox/omnibox_ui_handler.cc',
        'browser/ui/webui/omnibox/omnibox_ui_handler.h',
        'browser/ui/webui/options/advanced_options_utils.h',
        'browser/ui/webui/options/advanced_options_utils_mac.mm',
        'browser/ui/webui/options/advanced_options_utils_win.cc',
        'browser/ui/webui/options/advanced_options_utils_x11.cc',
        'browser/ui/webui/options/autofill_options_handler.cc',
        'browser/ui/webui/options/autofill_options_handler.h',
        'browser/ui/webui/options/browser_options_handler.cc',
        'browser/ui/webui/options/browser_options_handler.h',
        'browser/ui/webui/options/certificate_manager_handler.cc',
        'browser/ui/webui/options/certificate_manager_handler.h',
        'browser/ui/webui/options/chromeos/accounts_options_handler.cc',
        'browser/ui/webui/options/chromeos/accounts_options_handler.h',
        'browser/ui/webui/options/chromeos/bluetooth_options_handler.cc',
        'browser/ui/webui/options/chromeos/bluetooth_options_handler.h',
        'browser/ui/webui/options/chromeos/change_picture_options_handler.cc',
        'browser/ui/webui/options/chromeos/change_picture_options_handler.h',
        'browser/ui/webui/options/chromeos/core_chromeos_options_handler.cc',
        'browser/ui/webui/options/chromeos/core_chromeos_options_handler.h',
        'browser/ui/webui/options/chromeos/cros_language_options_handler.cc',
        'browser/ui/webui/options/chromeos/cros_language_options_handler.h',
        'browser/ui/webui/options/chromeos/display_options_handler.cc',
        'browser/ui/webui/options/chromeos/display_options_handler.h',
        'browser/ui/webui/options/chromeos/internet_options_handler.cc',
        'browser/ui/webui/options/chromeos/internet_options_handler.h',
        'browser/ui/webui/options/chromeos/keyboard_handler.cc',
        'browser/ui/webui/options/chromeos/keyboard_handler.h',
        'browser/ui/webui/options/chromeos/language_chewing_handler.cc',
        'browser/ui/webui/options/chromeos/language_chewing_handler.h',
        'browser/ui/webui/options/chromeos/language_hangul_handler.cc',
        'browser/ui/webui/options/chromeos/language_hangul_handler.h',
        'browser/ui/webui/options/chromeos/language_mozc_handler.cc',
        'browser/ui/webui/options/chromeos/language_mozc_handler.h',
        'browser/ui/webui/options/chromeos/language_options_util.cc',
        'browser/ui/webui/options/chromeos/language_options_util.h',
        'browser/ui/webui/options/chromeos/language_pinyin_handler.cc',
        'browser/ui/webui/options/chromeos/language_pinyin_handler.h',
        'browser/ui/webui/options/chromeos/pointer_handler.cc',
        'browser/ui/webui/options/chromeos/pointer_handler.h',
        'browser/ui/webui/options/chromeos/proxy_handler.cc',
        'browser/ui/webui/options/chromeos/proxy_handler.h',
        'browser/ui/webui/options/chromeos/set_wallpaper_options_handler.cc',
        'browser/ui/webui/options/chromeos/set_wallpaper_options_handler.h',
        'browser/ui/webui/options/chromeos/stats_options_handler.cc',
        'browser/ui/webui/options/chromeos/stats_options_handler.h',
        'browser/ui/webui/options/chromeos/timezone_options_util.cc',
        'browser/ui/webui/options/chromeos/timezone_options_util.h',
        'browser/ui/webui/options/chromeos/user_image_source.cc',
        'browser/ui/webui/options/chromeos/user_image_source.h',
        'browser/ui/webui/options/chromeos/wallpaper_source.cc',
        'browser/ui/webui/options/chromeos/wallpaper_source.h',
        'browser/ui/webui/options/chromeos/wallpaper_thumbnail_source.cc',
        'browser/ui/webui/options/chromeos/wallpaper_thumbnail_source.h',
        'browser/ui/webui/options/clear_browser_data_handler.cc',
        'browser/ui/webui/options/clear_browser_data_handler.h',
        'browser/ui/webui/options/content_settings_handler.cc',
        'browser/ui/webui/options/content_settings_handler.h',
        'browser/ui/webui/options/cookies_view_handler.cc',
        'browser/ui/webui/options/cookies_view_handler.h',
        'browser/ui/webui/options/core_options_handler.cc',
        'browser/ui/webui/options/core_options_handler.h',
        'browser/ui/webui/options/font_settings_handler.cc',
        'browser/ui/webui/options/font_settings_handler.h',
        'browser/ui/webui/options/font_settings_utils.h',
        'browser/ui/webui/options/font_settings_utils_mac.mm',
        'browser/ui/webui/options/font_settings_utils_win.cc',
        'browser/ui/webui/options/font_settings_utils_x11.cc',
        'browser/ui/webui/options/handler_options_handler.cc',
        'browser/ui/webui/options/handler_options_handler.h',
        'browser/ui/webui/options/home_page_overlay_handler.cc',
        'browser/ui/webui/options/home_page_overlay_handler.h',
        'browser/ui/webui/options/import_data_handler.cc',
        'browser/ui/webui/options/import_data_handler.h',
        'browser/ui/webui/options/language_options_handler.cc',
        'browser/ui/webui/options/language_options_handler.h',
        'browser/ui/webui/options/language_options_handler_common.cc',
        'browser/ui/webui/options/language_options_handler_common.h',
        'browser/ui/webui/options/manage_profile_handler.cc',
        'browser/ui/webui/options/manage_profile_handler.h',
        'browser/ui/webui/options/media_galleries_handler.cc',
        'browser/ui/webui/options/media_galleries_handler.h',
        'browser/ui/webui/options/options_sync_setup_handler.cc',
        'browser/ui/webui/options/options_sync_setup_handler.h',
        'browser/ui/webui/options/options_ui.cc',
        'browser/ui/webui/options/options_ui.h',
        'browser/ui/webui/options/password_manager_handler.cc',
        'browser/ui/webui/options/password_manager_handler.h',
        'browser/ui/webui/options/search_engine_manager_handler.cc',
        'browser/ui/webui/options/search_engine_manager_handler.h',
        'browser/ui/webui/options/startup_pages_handler.cc',
        'browser/ui/webui/options/startup_pages_handler.h',
        'browser/ui/webui/options/web_intents_settings_handler.cc',
        'browser/ui/webui/options/web_intents_settings_handler.h',
        'browser/ui/webui/performance_monitor/performance_monitor_l10n.cc',
        'browser/ui/webui/performance_monitor/performance_monitor_l10n.h',
        'browser/ui/webui/performance_monitor/performance_monitor_ui_constants.cc',
        'browser/ui/webui/performance_monitor/performance_monitor_ui_constants.h',
        'browser/ui/webui/performance_monitor/performance_monitor_ui_util.cc',
        'browser/ui/webui/performance_monitor/performance_monitor_ui_util.h',
        'browser/ui/webui/performance_monitor/performance_monitor_ui.cc',
        'browser/ui/webui/performance_monitor/performance_monitor_ui.h',
        'browser/ui/webui/performance_monitor/performance_monitor_handler.cc',
        'browser/ui/webui/performance_monitor/performance_monitor_handler.h',
        'browser/ui/webui/plugins_ui.cc',
        'browser/ui/webui/plugins_ui.h',
        'browser/ui/webui/policy_ui.cc',
        'browser/ui/webui/policy_ui.h',
        'browser/ui/webui/predictors/predictors_handler.cc',
        'browser/ui/webui/predictors/predictors_handler.h',
        'browser/ui/webui/predictors/predictors_ui.cc',
        'browser/ui/webui/predictors/predictors_ui.h',
        'browser/ui/webui/print_preview/print_preview_data_source.cc',
        'browser/ui/webui/print_preview/print_preview_data_source.h',
        'browser/ui/webui/print_preview/print_preview_handler.cc',
        'browser/ui/webui/print_preview/print_preview_handler.h',
        'browser/ui/webui/print_preview/print_preview_ui.cc',
        'browser/ui/webui/print_preview/print_preview_ui.h',
        'browser/ui/webui/print_preview/sticky_settings.cc',
        'browser/ui/webui/print_preview/sticky_settings.h',
        'browser/ui/webui/profiler_ui.cc',
        'browser/ui/webui/profiler_ui.h',
        'browser/ui/webui/quota_internals_handler.cc',
        'browser/ui/webui/quota_internals_handler.h',
        'browser/ui/webui/quota_internals_proxy.cc',
        'browser/ui/webui/quota_internals_proxy.h',
        'browser/ui/webui/quota_internals_types.cc',
        'browser/ui/webui/quota_internals_types.h',
        'browser/ui/webui/quota_internals_ui.cc',
        'browser/ui/webui/quota_internals_ui.h',
        'browser/ui/webui/screenshot_source.cc',
        'browser/ui/webui/screenshot_source.h',
        'browser/ui/webui/session_favicon_source.cc',
        'browser/ui/webui/session_favicon_source.h',
        'browser/ui/webui/shared_resources_data_source.cc',
        'browser/ui/webui/shared_resources_data_source.h',
        'browser/ui/webui/signin/login_ui_service.cc',
        'browser/ui/webui/signin/login_ui_service.h',
        'browser/ui/webui/signin/login_ui_service_factory.cc',
        'browser/ui/webui/signin/login_ui_service_factory.h',
        'browser/ui/webui/suggestions_internals/suggestions_internals_ui.cc',
        'browser/ui/webui/suggestions_internals/suggestions_internals_ui.h',
        'browser/ui/webui/suggestions_internals/suggestions_internals_ui_handler.cc',
        'browser/ui/webui/suggestions_internals/suggestions_internals_ui_handler.h',
        'browser/ui/webui/sync_internals_ui.cc',
        'browser/ui/webui/sync_internals_ui.h',
        'browser/ui/webui/sync_promo/sync_promo_handler.cc',
        'browser/ui/webui/sync_promo/sync_promo_handler.h',
        'browser/ui/webui/sync_promo/sync_promo_trial.cc',
        'browser/ui/webui/sync_promo/sync_promo_trial.h',
        'browser/ui/webui/sync_promo/sync_promo_ui.cc',
        'browser/ui/webui/sync_promo/sync_promo_ui.h',
        'browser/ui/webui/sync_setup_handler.cc',
        'browser/ui/webui/sync_setup_handler.h',
        'browser/ui/webui/tab_modal_confirm_dialog_webui.cc',
        'browser/ui/webui/tab_modal_confirm_dialog_webui.h',
        'browser/ui/webui/task_manager/task_manager_dialog.cc',
        'browser/ui/webui/task_manager/task_manager_dialog.h',
        'browser/ui/webui/task_manager/task_manager_handler.cc',
        'browser/ui/webui/task_manager/task_manager_handler.h',
        'browser/ui/webui/task_manager/task_manager_ui.cc',
        'browser/ui/webui/task_manager/task_manager_ui.h',
        'browser/ui/webui/test_chrome_web_ui_controller_factory.cc',
        'browser/ui/webui/test_chrome_web_ui_controller_factory.h',
        'browser/ui/webui/theme_source.cc',
        'browser/ui/webui/theme_source.h',
        'browser/ui/webui/tracing_ui.cc',
        'browser/ui/webui/tracing_ui.h',
        'browser/ui/webui/uber/uber_ui.cc',
        'browser/ui/webui/uber/uber_ui.h',
        'browser/ui/webui/version_handler.cc',
        'browser/ui/webui/version_handler.h',
        'browser/ui/webui/version_handler_chromeos.cc',
        'browser/ui/webui/version_handler_chromeos.h',
        'browser/ui/webui/version_ui.cc',
        'browser/ui/webui/version_ui.h',
        'browser/ui/webui/web_ui_util.cc',
        'browser/ui/webui/web_ui_util.h',
        'browser/ui/webui/welcome_ui_android.cc',
        'browser/ui/webui/welcome_ui_android.h',
        'browser/ui/window_sizer/window_sizer.cc',
        'browser/ui/window_sizer/window_sizer.h',
        'browser/ui/window_sizer/window_sizer_ash.cc',
        'browser/ui/window_sizer/window_sizer_aura.cc',
        'browser/ui/window_sizer/window_sizer_gtk.cc',
        'browser/ui/window_sizer/window_sizer_mac.mm',
        'browser/ui/window_sizer/window_sizer_win.cc',
        'browser/ui/window_snapshot/window_snapshot.cc',
        'browser/ui/window_snapshot/window_snapshot.h',
        'browser/ui/window_snapshot/window_snapshot_aura.cc',
        'browser/ui/window_snapshot/window_snapshot_gtk.cc',
        'browser/ui/window_snapshot/window_snapshot_mac.mm',
        'browser/ui/window_snapshot/window_snapshot_win.cc',
        'browser/ui/zoom/zoom_controller.cc',
        'browser/ui/zoom/zoom_controller.h',
        'browser/ui/zoom/zoom_observer.h',
      ],
      'conditions': [
        ['enable_one_click_signin==0', {
          'sources!': [
            'browser/ui/cocoa/one_click_signin_bubble_controller.h',
            'browser/ui/cocoa/one_click_signin_bubble_controller.mm',
            'browser/ui/gtk/one_click_signin_bubble_gtk.cc',
            'browser/ui/gtk/one_click_signin_bubble_gtk.h',
            'browser/ui/sync/one_click_signin_helper.cc',
            'browser/ui/sync/one_click_signin_helper.h',
            'browser/ui/sync/one_click_signin_histogram.h',
            'browser/ui/sync/one_click_signin_sync_starter.cc',
            'browser/ui/sync/one_click_signin_sync_starter.h',
            'browser/ui/views/infobars/one_click_signin_infobar.cc',
            'browser/ui/views/infobars/one_click_signin_infobar.h',
            'browser/ui/views/sync/one_click_signin_bubble_view.cc',
            'browser/ui/views/sync/one_click_signin_bubble_view.h',
          ]
        }],
        ['enable_task_manager==0', {
          'sources/': [
            ['exclude', '^browser/ui/webui/task_manager/'],
            ['exclude', '^browser/ui/views/task_manager_view.cc'],
            ['exclude', '^browser/ui/cocoa/task_manager_mac.h'],
            ['exclude', '^browser/ui/cocoa/task_manager_mac.mm'],
            ['exclude', '^browser/ui/gtk/task_manager_gtk.cc'],
            ['exclude', '^browser/ui/gtk/task_manager_gtk.h'],
          ],
        }],
        ['disable_nacl==0', {
          'sources': [
            'browser/ui/webui/nacl_ui.cc',
            'browser/ui/webui/nacl_ui.h',
          ],
          'dependencies': [
            '../native_client/src/trusted/service_runtime/service_runtime.gyp:sel',
          ],
        }],
        ['debug_devtools==1', {
          'defines': [
            'DEBUG_DEVTOOLS=1',
          ],
        }],
        ['configuration_policy!=1', {
          'sources/': [
            ['exclude', 'browser/ui/webui/policy_ui.cc'],
            ['exclude', 'browser/ui/webui/policy_ui.h'],
          ],
        }],
        ['safe_browsing==1', {
          'defines': [
            'ENABLE_SAFE_BROWSING',
          ],
        }, {  # safe_browsing==0
          'dependencies!': [
            'safe_browsing_proto',
            'safe_browsing_report_proto',
            '../third_party/libusb/libusb.gyp:libusb',
          ],
        }],
        ['toolkit_views == 0', {
          'sources!': [
            'browser/ui/tabs/tab_strip_layout_type.h',
            'browser/ui/tabs/tab_strip_layout_type_prefs.cc',
            'browser/ui/tabs/tab_strip_layout_type_prefs.h',
          ],
        }],
        ['OS=="linux"', {
          'dependencies': [
            '../build/linux/system.gyp:udev',
          ],
        }],
        ['chromeos==0', {
          'sources/': [
            ['exclude', '^browser/ui/webui/chromeos'],
            ['exclude', '^browser/ui/webui/options/chromeos'],
            ['exclude', 'browser/ui/toolbar/wrench_menu_model_chromeos.cc'],
          ],
        }, {  # chromeos==1
          'dependencies': [
            'browser_chromeos',
          ],
          'sources/': [
            ['exclude', 'browser/first_run/upgrade_util.cc'],
            ['exclude', 'browser/first_run/upgrade_util.h'],
            ['exclude', 'browser/first_run/upgrade_util_linux.cc'],
            ['exclude', 'browser/icon_loader_linux.cc'],
            ['exclude', 'browser/icon_manager_linux.cc'],
            ['exclude', 'browser/idle_linux.cc'],
            ['exclude', 'browser/password_manager/native_backend_gnome_x.cc'],
            ['exclude', 'browser/password_manager/native_backend_gnome_x.h'],
            ['exclude', 'browser/password_manager/native_backend_kwallet_x.cc'],
            ['exclude', 'browser/password_manager/native_backend_kwallet_x.h'],
            ['exclude', 'browser/policy/user_cloud_policy_store.cc'],
            ['exclude', 'browser/policy/user_cloud_policy_store.h'],
            ['exclude', 'browser/policy/user_policy_signin_service.cc'],
            ['exclude', 'browser/policy/user_policy_signin_service.h'],
            ['exclude', 'browser/policy/user_policy_signin_service_factory.cc'],
            ['exclude', 'browser/policy/user_policy_signin_service_factory.h'],
            ['exclude', 'browser/platform_util_linux.cc'],
            ['exclude', 'browser/speech/extension_api/tts_extension_api_linux.cc'],
            ['exclude', 'browser/system_monitor/media_storage_util_linux.cc'],
            ['exclude', 'browser/system_monitor/removable_device_notifications_linux.cc'],
            ['exclude', 'browser/system_monitor/removable_device_notifications_linux.h'],
            ['exclude', 'browser/ui/views/frame/desktop_browser_frame_aura.cc'],
            ['exclude', 'browser/ui/views/frame/desktop_browser_frame_aura.h'],
            ['exclude', 'browser/ui/webui/help/version_updater_basic.cc'],
            ['exclude', 'browser/ui/webui/help/version_updater_basic.h'],
            ['exclude', 'browser/upgrade_detector_impl.cc'],
            ['exclude', 'browser/upgrade_detector_impl.h'],
          ],
        }],
        ['use_ibus==1', {
          'dependencies': [
            '../build/linux/system.gyp:ibus',
          ],
        }],
        ['use_cups==1', {
          'dependencies': [
            '../printing/printing.gyp:cups',
          ],
        }],
        ['use_gconf==0', {
          'sources!': [
            'browser/ui/gtk/gconf_titlebar_listener.cc',
            'browser/ui/gtk/gconf_titlebar_listener.h',
          ],
        }],
        ['use_ash==1', {
          'sources': [
            'browser/ui/app_list/app_list_view_delegate.cc',
            'browser/ui/app_list/app_list_view_delegate.h',
            'browser/ui/app_list/apps_model_builder.cc',
            'browser/ui/app_list/apps_model_builder.h',
            'browser/ui/app_list/chrome_app_list_item.h',
            'browser/ui/app_list/extension_app_item.cc',
            'browser/ui/app_list/extension_app_item.h',
            'browser/ui/app_list/search_builder.cc',
            'browser/ui/app_list/search_builder.h',
          ],
          'dependencies': [
            '../ash/ash.gyp:ash',
            '../ash/ash_strings.gyp:ash_strings',
            '../ui/app_list/app_list.gyp:app_list',
            '../ui/message_center/message_center.gyp:message_center',
          ],
        }],
        ['use_aura==1 and use_ash==0 and OS=="linux"', {
          'dependencies': [
            # gtk2 is the only component that can interact with gtk2 in our new
            # world.
            'browser/ui/libgtk2ui/libgtk2ui.gyp:gtk2ui',
          ],
        }],
        ['use_aura==1', {
          'sources/': [
            ['exclude', '^browser/ui/panels/display_settings_provider_win.cc'],
            ['exclude', '^browser/ui/panels/taskbar_window_thumbnailer_win.cc'],
            ['exclude', '^browser/ui/panels/taskbar_window_thumbnailer_win.h'],
            ['exclude', '^browser/ui/views/about_ipc_dialog.cc'],
            ['exclude', '^browser/ui/views/app_menu_button_win.cc'],
            ['exclude', '^browser/ui/views/certificate_viewer_win.cc'],
            ['exclude', '^browser/ui/views/dropdown_bar_host_win.cc'],
            ['exclude', '^browser/ui/views/external_protocol_dialog.cc'],
            ['exclude', '^browser/ui/views/external_tab_container_win.cc'],
            ['exclude', '^browser/ui/views/external_tab_container_win.h'],
            ['exclude', '^browser/ui/views/find_bar_host_win.cc'],
            ['exclude', '^browser/ui/views/frame/browser_frame_win.cc'],
            ['exclude', '^browser/ui/views/frame/browser_frame_win.h'],
            ['exclude', '^browser/ui/views/frame/browser_non_client_frame_view_factory_win.cc'],
            ['exclude', '^browser/ui/views/frame/system_menu_model.cc'],
            ['exclude', '^browser/ui/views/frame/system_menu_model.h'],
            ['exclude', '^browser/ui/views/importer/import_progress_dialog_view.cc'],
            ['exclude', '^browser/ui/views/location_bar/location_bar_container_win.cc'],
            ['exclude', '^browser/ui/views/native_constrained_window_win.cc'],
            ['exclude', '^browser/ui/views/omnibox/omnibox_view_win.cc'],
            ['exclude', '^browser/ui/views/omnibox/omnibox_view_win.h'],
            ['exclude', '^browser/ui/views/color_chooser_dialog.cc'],
            ['exclude', '^browser/ui/views/color_chooser_dialog.h'],
            ['exclude', '^browser/ui/views/color_chooser_win.cc'],
            ['exclude', '^browser/ui/views/select_file_dialog_win.cc'],
            ['exclude', '^browser/ui/views/simple_message_box_win.cc'],
            ['exclude', '^browser/ui/views/tabs/dock_info_win.cc'],
            ['exclude', '^browser/ui/views/tabs/native_view_photobooth.h'],
            ['exclude', '^browser/ui/views/tabs/native_view_photobooth_win.cc'],
            ['exclude', '^browser/ui/views/tabs/native_view_photobooth_win.h'],
            ['exclude', '^browser/ui/views/task_manager_view.cc'],
            ['exclude', '^browser/ui/views/task_manager_view.h'],
            ['exclude', '^browser/ui/views/user_data_dir_dialog_view.cc'],
            ['exclude', '^browser/ui/webui/help/version_updater_win.cc'],
            ['exclude', '^browser/ui/window_sizer/window_sizer_win.cc'],
            ['exclude', '^browser/ui/window_snapshot/window_snapshot_win.cc'],
            # TODO: (stevenjb/beng): Find a home for these.
            ['include', '^browser/ui/views/simple_message_box_views.cc'],
            ['include', '^browser/ui/webui/certificate_viewer_webui.cc'],
            ['include', '^browser/ui/webui/certificate_viewer_webui.h'],
            ['include', '^browser/ui/webui/certificate_viewer_ui.cc'],
            ['include', '^browser/ui/webui/certificate_viewer_ui.h'],
          ],
          'dependencies': [
            # aura uses some of ash resources.
            '../ash/ash.gyp:ash_resources',
            '../ui/aura/aura.gyp:aura',
          ],
          'conditions': [
            ['OS=="win"', {
              'sources/': [
                ['exclude', '^browser/ui/webui/certificate_viewer_webui.cc'],
                ['exclude', '^browser/ui/webui/certificate_viewer_webui.h'],
                ['exclude', '^browser/ui/webui/certificate_viewer_ui.cc'],
                ['exclude', '^browser/ui/webui/certificate_viewer_ui.h'],
                ['include', 'browser/ui/browser_win.cc'],
                ['include', 'browser/ui/webui/help/version_updater_basic.cc'],
                ['include', 'browser/ui/webui/help/version_updater_basic.h'],
              ],
            }, {
              'sources/': [
                ['exclude', '^browser/ui/views/frame/glass_browser_frame_view.cc'],
                ['exclude', '^browser/ui/views/frame/glass_browser_frame_view.h'],
              ],
            }],
          ],
        }, { # else: use_aura==0
          'sources/': [
            ['exclude', '^browser/ui/views/frame/browser_desktop_root_window_host.h'],
            ['exclude', '^browser/ui/views/frame/browser_desktop_root_window_host_linux.cc'],
            ['exclude', '^browser/ui/views/frame/browser_desktop_root_window_host_linux.h'],
            ['exclude', '^browser/ui/views/frame/browser_desktop_root_window_host_win.cc'],
            ['exclude', '^browser/ui/views/frame/browser_desktop_root_window_host_win.h'],
            ['exclude', '^browser/ui/webui/gesture_config_ui.cc'],
            ['exclude', '^browser/ui/webui/gesture_config_ui.h'],
            ['exclude', '^browser/ui/webui/task_manager/'],
          ],
        }],
        ['ui_compositor_image_transport==1', {
          'dependencies': [
            '../ui/gl/gl.gyp:gl',
          ],
        }],
        ['os_posix == 1 and OS != "mac" and OS != "android"', {
          'link_settings': {
            'libraries': [
              '-lXss',
            ],
          },
        }],
        ['use_nss!=1', {
          'sources!': [
            'browser/ui/webui/options/certificate_manager_handler.cc',
            'browser/ui/webui/options/certificate_manager_handler.h',
          ],
        }],
        ['use_nss==0 and use_openssl==0', {
          'sources!': [
            'browser/ui/webui/certificate_viewer_webui.cc',
            'browser/ui/webui/certificate_viewer_webui.h',
            'browser/ui/webui/certificate_viewer_ui.cc',
            'browser/ui/webui/certificate_viewer_ui.h',
          ],
        }],
        ['toolkit_uses_gtk == 1', {
          'dependencies': [
            '../build/linux/system.gyp:dbus',
            '../build/linux/system.gyp:gconf',
            '../build/linux/system.gyp:gtk',
            '../build/linux/system.gyp:gtkprint',
            '../build/linux/system.gyp:ssl',
            '../build/linux/system.gyp:x11',
            '../dbus/dbus.gyp:dbus',
            '../third_party/undoview/undoview.gyp:undoview',
          ],
          'sources': [
            'browser/ui/startup/obsolete_os_info_bar.cc',
            'browser/ui/startup/obsolete_os_info_bar.h',
          ],
        }],
        ['enable_themes==0', {
          'sources!': [
            'browser/ui/webui/theme_source.cc',
          ],
        }],
        ['enable_printing!=1', {
          'sources/': [
            ['exclude', '^browser/ui/webui/print_preview/'],
          ],
        }],
        ['OS=="android"', {
          'dependencies': [
            'browser/component/components.gyp:web_contents_delegate_android',
            'chrome_browser_jni_headers',
          ],
          'sources': [
            'browser/ui/find_bar/find_match_rects_details.cc',
            'browser/ui/find_bar/find_match_rects_details.h',
            'browser/ui/webui/ntp/android/bookmarks_handler.cc',
            'browser/ui/webui/ntp/android/bookmarks_handler.h',
            'browser/ui/webui/ntp/android/context_menu_handler.cc',
            'browser/ui/webui/ntp/android/context_menu_handler.h',
            'browser/ui/webui/ntp/android/new_tab_page_ready_handler.cc',
            'browser/ui/webui/ntp/android/new_tab_page_ready_handler.h',
            'browser/ui/webui/ntp/android/partner_bookmarks_shim.cc',
            'browser/ui/webui/ntp/android/partner_bookmarks_shim.h',
            'browser/ui/webui/ntp/android/promo_handler.cc',
            'browser/ui/webui/ntp/android/promo_handler.h',
          ],
          'sources!': [
            # Android uses native UI for sync setup.
            'browser/ui/webui/ntp/new_tab_page_sync_handler.cc',
            'browser/ui/webui/ntp/new_tab_page_sync_handler.h',
            'browser/ui/webui/ntp/new_tab_sync_setup_handler.cc',
            'browser/ui/webui/ntp/new_tab_sync_setup_handler.h',
            'browser/ui/webui/ntp/ntp_login_handler.cc',
            'browser/ui/webui/ntp/ntp_login_handler.h',
            'browser/ui/webui/sync_setup_handler.cc',
            'browser/ui/webui/sync_setup_handler.h',

            # There's no Browser/BrowserList on Android.
            'browser/ui/bookmarks/bookmark_context_menu_controller.cc',
            'browser/ui/browser.cc',
            'browser/ui/browser_command_controller.cc',
            'browser/ui/browser_finder.cc',
            'browser/ui/browser_instant_controller.cc',
            'browser/ui/browser_list.cc',
            'browser/ui/browser_navigator.cc',
            'browser/ui/browser_otr_state.cc',
            'browser/ui/browser_tab_restore_service_delegate.cc',
            'browser/ui/browser_tabstrip.cc',
            'browser/ui/browser_tabstrip.h',
            'browser/ui/chrome_pages.cc',
            'browser/ui/chrome_pages.h',
            'browser/ui/ntp_background_util.cc',
            'browser/ui/ntp_background_util.h',
            'browser/ui/sad_tab_helper.cc',
            'browser/ui/search/other_device_menu_controller.cc',
            'browser/ui/search/other_device_menu_controller.h',
            'browser/ui/singleton_tabs.cc',
            'browser/ui/singleton_tabs.h',
            'browser/ui/sync/browser_synced_window_delegate.cc',
            'browser/ui/tab_contents/tab_contents_iterator.cc',
            'browser/ui/uma_browsing_activity_observer.cc',
            'browser/ui/uma_browsing_activity_observer.h',
            'browser/ui/webui/bookmarks_ui.cc',
            'browser/ui/webui/bookmarks_ui.h',
            'browser/ui/webui/certificate_viewer_webui.cc',
            'browser/ui/webui/extensions/command_handler.cc',
            'browser/ui/webui/extensions/extension_settings_handler.cc',
            'browser/ui/webui/extensions/extension_settings_handler.h',
            'browser/ui/webui/extensions/extensions_ui.cc',
            'browser/ui/webui/extensions/install_extension_handler.cc',
            'browser/ui/webui/inspect_ui.cc',
            'browser/ui/webui/inspect_ui.h',
            'browser/ui/webui/ntp/app_launcher_handler.cc',
            'browser/ui/webui/ntp/app_launcher_handler.h',
            'browser/ui/webui/ntp/new_tab_page_handler.cc',
            'browser/ui/webui/ntp/new_tab_page_handler.h',
            'browser/ui/webui/ntp/ntp_resource_cache.cc',
            'browser/ui/webui/ntp/suggestions_combiner.cc',
            'browser/ui/webui/ntp/suggestions_combiner.h',
            'browser/ui/webui/ntp/suggestions_page_handler.cc',
            'browser/ui/webui/ntp/suggestions_page_handler.h',
            'browser/ui/webui/ntp/suggestions_source.h',
            'browser/ui/webui/ntp/suggestions_source_discovery.cc',
            'browser/ui/webui/ntp/suggestions_source_discovery.h',
            'browser/ui/webui/ntp/suggestions_source_top_sites.cc',
            'browser/ui/webui/ntp/suggestions_source_top_sites.h',
            'browser/ui/webui/performance_monitor/web_ui.cc',
            'browser/ui/webui/performance_monitor/web_ui_handler.cc',
            'browser/ui/webui/plugins_ui.cc',
            'browser/ui/webui/plugins_ui.h',
            'browser/ui/webui/suggestions_internals/suggestions_internals_ui.cc',
            'browser/ui/webui/suggestions_internals/suggestions_internals_ui.h',
            'browser/ui/webui/suggestions_internals/suggestions_internals_ui_handler.cc',
            'browser/ui/webui/suggestions_internals/suggestions_internals_ui_handler.h',
            'browser/ui/webui/tracing_ui.cc',
            'browser/ui/webui/tracing_ui.h',
            'browser/ui/window_sizer/window_sizer.cc',
            'browser/ui/window_sizer/window_sizer.h',
          ],
          'sources/': [
            ['exclude', '^browser/ui/intents/'],
            ['exclude', '^browser/ui/omnibox/'],
            ['exclude', '^browser/ui/panels/'],
            ['exclude', '^browser/ui/pdf/'],
            ['exclude', '^browser/ui/startup/'],
            ['exclude', '^browser/ui/tabs/'],
            ['exclude', '^browser/ui/toolbar/'],
            ['exclude', '^browser/ui/webui/downloads_'],
            ['exclude', '^browser/ui/webui/feedback_'],
            ['exclude', '^browser/ui/webui/flags_'],
            ['exclude', '^browser/ui/webui/help/'],
            ['exclude', '^browser/ui/webui/inspect_'],
            ['exclude', '^browser/ui/webui/options'],
            ['exclude', '^browser/ui/webui/options'],
            ['exclude', '^browser/ui/webui/signin/'],
            ['exclude', '^browser/ui/webui/suggestions_internals'],
            ['exclude', '^browser/ui/webui/sync_promo'],
            ['exclude', '^browser/ui/webui/uber'],
          ],
        }],
        ['OS=="mac"', {
          'sources!': [
            'browser/ui/certificate_dialogs.cc',
            'browser/ui/certificate_dialogs.h',
            'browser/ui/crypto_module_password_dialog.cc',
            'browser/ui/crypto_module_password_dialog_nss.cc',
            'browser/ui/panels/panel_browser_frame_view.cc',
            'browser/ui/panels/panel_browser_frame_view.h',
            'browser/ui/panels/panel_browser_view.cc',
            'browser/ui/panels/panel_browser_view.h',
            'browser/ui/panels/panel_frame_view.cc',
            'browser/ui/panels/panel_frame_view.h',
            'browser/ui/panels/panel_view.cc',
            'browser/ui/panels/panel_view.h',
            'browser/ui/tabs/dock_info.cc',
            'browser/ui/tabs/tab_resources.cc',
            'browser/ui/views/extensions/extension_view_views.cc',
            'browser/ui/views/extensions/extension_view_views.h',
            'browser/ui/webui/help/version_updater_basic.cc',
            'browser/ui/webui/help/version_updater_basic.h',
          ],
          'sources': [
            # Build Apple sample code
            '../third_party/apple_sample_code/ImageAndTextCell.h',
            '../third_party/apple_sample_code/ImageAndTextCell.m',
            # Build the necessary GTM sources
            '../third_party/GTM/AppKit/GTMFadeTruncatingTextFieldCell.h',
            '../third_party/GTM/AppKit/GTMFadeTruncatingTextFieldCell.m',
            '../third_party/GTM/AppKit/GTMIBArray.h',
            '../third_party/GTM/AppKit/GTMIBArray.m',
            '../third_party/GTM/AppKit/GTMKeyValueAnimation.h',
            '../third_party/GTM/AppKit/GTMKeyValueAnimation.m',
            '../third_party/GTM/AppKit/GTMNSAnimation+Duration.h',
            '../third_party/GTM/AppKit/GTMNSAnimation+Duration.m',
            '../third_party/GTM/AppKit/GTMNSBezierPath+CGPath.h',
            '../third_party/GTM/AppKit/GTMNSBezierPath+CGPath.m',
            '../third_party/GTM/AppKit/GTMNSBezierPath+RoundRect.m',
            '../third_party/GTM/AppKit/GTMNSColor+Luminance.m',
            '../third_party/GTM/AppKit/GTMUILocalizer.h',
            '../third_party/GTM/AppKit/GTMUILocalizer.m',
            '../third_party/GTM/AppKit/GTMUILocalizerAndLayoutTweaker.h',
            '../third_party/GTM/AppKit/GTMUILocalizerAndLayoutTweaker.m',
            '../third_party/GTM/AppKit/GTMWindowSheetController.m',
            '../third_party/GTM/Foundation/GTMNSNumber+64Bit.h',
            '../third_party/GTM/Foundation/GTMNSNumber+64Bit.m',
            '../third_party/GTM/Foundation/GTMNSObject+KeyValueObserving.h',
            '../third_party/GTM/Foundation/GTMNSObject+KeyValueObserving.m',
            # MolokoCacao additions
            '../third_party/molokocacao/NSBezierPath+MCAdditions.h',
            '../third_party/molokocacao/NSBezierPath+MCAdditions.m',
            # Build necessary Mozilla sources
            '../third_party/mozilla/NSScreen+Utils.h',
            '../third_party/mozilla/NSScreen+Utils.m',
            '../third_party/mozilla/NSWorkspace+Utils.h',
            '../third_party/mozilla/NSWorkspace+Utils.m',
            # Additional files for use only on Mac and Gtk.
            'browser/ui/startup/obsolete_os_info_bar.cc',
            'browser/ui/startup/obsolete_os_info_bar.h',
          ],
          'include_dirs': [
            '../third_party/apple',
            '../third_party/GTM',
            '../third_party/GTM/AppKit',
            '../third_party/GTM/DebugUtils',
            '../third_party/GTM/Foundation',
          ],
          'actions': [
            {
              # This action is used to extract the localization data from xib
              # files and generate table for the ui localizer from it.
              'variables': {
                'xib_localizer_tool_path':
                    'tools/build/mac/generate_localizer',
              },
              'includes': [
                'chrome_nibs.gypi',
              ],
              'action_name': 'Process xibs for localization',
              'inputs': [
                '<(xib_localizer_tool_path)',
                '<@(mac_translated_xibs)',
              ],
              'outputs': [
                '<(INTERMEDIATE_DIR)/ui_localizer_table.h',
              ],
              'action': ['<(xib_localizer_tool_path)',
                          '<@(_outputs)',
                          '<@(mac_translated_xibs)'],
            },
          ],
        }],
        ['OS=="win"', {
          'include_dirs': [
            '<(DEPTH)/third_party/wtl/include',
          ],
          'dependencies': [
            'installer_util_strings',
            '../google_update/google_update.gyp:google_update',
            '../third_party/iaccessible2/iaccessible2.gyp:iaccessible2',
            '../third_party/isimpledom/isimpledom.gyp:isimpledom',
            '../ui/app_list/app_list.gyp:app_list',
            '../ui/views/controls/webview/webview.gyp:webview',
            '../ui/views/views.gyp:views',
          ],
          'export_dependent_settings': [
            '../ui/views/controls/webview/webview.gyp:webview',
            '../ui/views/views.gyp:views',
          ],
          'sources': [
            'browser/ui/app_list/app_list_view_delegate.cc',
            'browser/ui/app_list/app_list_view_delegate.h',
            'browser/ui/app_list/apps_model_builder.cc',
            'browser/ui/app_list/apps_model_builder.h',
            'browser/ui/app_list/chrome_app_list_item.h',
            'browser/ui/app_list/extension_app_item.cc',
            'browser/ui/app_list/extension_app_item.h',
            'browser/ui/app_list/search_builder.cc',
            'browser/ui/app_list/search_builder.h',
            'browser/ui/views/network_profile_bubble_view.cc',
            'browser/ui/views/network_profile_bubble_view.h',
            'browser/ui/webui/conflicts_ui.cc',
            'browser/ui/webui/conflicts_ui.h',
          ],
          'sources!': [
            'browser/ui/certificate_dialogs.cc',
            'browser/ui/certificate_dialogs.h',
            'browser/ui/crypto_module_password_dialog.cc',
            'browser/ui/crypto_module_password_dialog_nss.cc',
            'browser/ui/startup/autolaunch_prompt.cc',
            'browser/ui/views/simple_message_box_views.cc',
            'browser/ui/webui/help/version_updater_basic.cc',
            'browser/ui/webui/help/version_updater_basic.h',
            'browser/ui/webui/tab_modal_confirm_dialog_webui.cc',
            'browser/ui/webui/tab_modal_confirm_dialog_webui.h',
          ],
          'conditions': [
            ['win_use_allocator_shim==1', {
              'dependencies': [
                '<(allocator_target)',
              ],
            }],
          ],
        }, {  # 'OS!="win"
          'sources/': [
            # Exclude files that should be excluded for all non-Windows platforms.
            ['exclude', '^browser/ui/network_profile_bubble.cc'],
            ['exclude', '^browser/ui/network_profile_bubble.h'],
            ['exclude', '^browser/ui/webui/set_as_default_browser_ui.cc'],
            ['exclude', '^browser/ui/webui/set_as_default_browser_ui.h'],
          ],
          'conditions': [
            ['use_aura==1',{
              'dependencies': [
                '../build/linux/system.gyp:dbus',
                '../build/linux/system.gyp:fontconfig',
                '../build/linux/system.gyp:x11',
                '../dbus/dbus.gyp:dbus',
                '../ui/views/controls/webview/webview.gyp:webview',
                '../ui/views/views.gyp:views',
              ],
              'include_dirs': [
                '<(INTERMEDIATE_DIR)',
                '<(INTERMEDIATE_DIR)/chrome',
              ],
              'sources/': [
                ['exclude', '^browser/ui/views/frame/app_panel_browser_frame_view.cc'],
                ['exclude', '^browser/ui/views/frame/app_panel_browser_frame_view.h'],
                ['exclude', '^browser/ui/views/theme_helpers.cc'],
                ['exclude', '^browser/ui/views/theme_helpers.h'],
                ['exclude', '^browser/ui/views/uninstall_view.cc'],
                ['exclude', '^browser/ui/views/uninstall_view.h'],
                ['include', '^browser/ui/tabs/dock_info.cc'],
                ['include', '^browser/ui/tabs/dock_info.h'],
                ['include', '^browser/ui/views/speech_recognition_bubble_views.cc'],
                ['include', '^browser/ui/window_sizer/window_sizer.cc'],
                ['include', '^browser/ui/window_sizer/window_sizer.h'],
              ],
            }, { # else: use_aura==0
              'sources/': [
                # Exclude all of views.
                ['exclude', '^browser/ui/views/'],
                ['exclude', '^browser/ui/webui/tab_modal_confirm_dialog_webui.cc'],
                ['exclude', '^browser/ui/webui/tab_modal_confirm_dialog_webui.h']
              ]
            }],
            # GTK build only
            ['toolkit_uses_gtk==1', {
              'sources/': [
                ['exclude', '^browser/ui/panels/panel_browser_frame_view.cc'],
                ['exclude', '^browser/ui/panels/panel_browser_frame_view.h'],
                ['exclude', '^browser/ui/panels/panel_browser_view.cc'],
                ['exclude', '^browser/ui/panels/panel_browser_view.h'],
                ['exclude', '^browser/ui/panels/panel_frame_view.cc'],
                ['exclude', '^browser/ui/panels/panel_frame_view.h'],
                ['exclude', '^browser/ui/panels/panel_view.cc'],
                ['exclude', '^browser/ui/panels/panel_view.h'],
                ['exclude', '^browser/ui/toolbar/bookmark_sub_menu_model.cc'],
                ['exclude', '^browser/ui/views/notifications/balloon_collection_views.cc'],
              ],
            }],
          ],
        }],
        [ 'use_openssl==1', {
          'sources!': [
            'browser/ui/crypto_module_password_dialog_nss.cc',
          ]}, {
           'sources!': [
             'browser/ui/crypto_module_password_dialog_openssl.cc',
          ]},
        ],
        # File manager extension replaces the native OS file open/save dialog.
        ['file_manager_extension==1', {
          'sources/': [
            ['include', '^browser/ui/views/select_file_dialog_extension.cc'],
            ['include', '^browser/ui/views/select_file_dialog_extension.h'],
            ['include', '^browser/ui/views/select_file_dialog_extension_factory.cc'],
            ['include', '^browser/ui/views/select_file_dialog_extension_factory.h'],
          ]}, {
          'sources/': [
            ['exclude', '^browser/ui/views/select_file_dialog_extension.cc'],
            ['exclude', '^browser/ui/views/select_file_dialog_extension.h'],
            ['exclude', '^browser/ui/views/select_file_dialog_extension_factory.cc'],
            ['exclude', '^browser/ui/views/select_file_dialog_extension_factory.h'],
          ]}
        ],
      ],
    },
  ],
}
