/*
 * Copyright (c) 2012 The Native Client Authors. All rights reserved.
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 */

/* Common definitions for the generator of all instructions and the definitions
 * of the DFA generated by the parse_dfa.py.  */

#ifndef _TEST_DFA_H
#define _TEST_DFA_H

#include <stdbool.h>
#include <stdint.h>

struct state {
  uint16_t transitions[256];
  bool is_final;
  bool anyfield_begin;
  bool anyfield_end;
};

extern struct state states[];

uint16_t NumStates();

void AddRange(int state_idx,
              uint8_t byte_begin,
              uint8_t byte_end,
              uint16_t target);

void InitTransitions();

extern uint16_t start_state;

#endif  /* _TEST_DFA_H */
